﻿Public Class ClasificationConcept

    Private conceptName As String

    Private _classifiedResources As List(Of Resource)
    Public Property classifiedResources() As List(Of Resource)
        Get
            Return _classifiedResources
        End Get
        Set(ByVal value As List(Of Resource))
            _classifiedResources = value
        End Set
    End Property

    Public Sub New()
        classifiedResources = New List(Of Resource)
        conceptName = ""
    End Sub

    Public Sub setConceptName(ByVal s As String)
        conceptName = s
    End Sub

    Public Function getConceptName() As String
        Return conceptName
    End Function

    Public Sub add(ByVal r As Resource)
        classifiedResources.Add(r)
    End Sub

    Public Overrides Function ToString() As String
        Dim cadena As String = ""

        For Each r As Resource In classifiedResources
            cadena &= r.id + "   "
        Next

        cadena &= "   " + conceptName
        Return cadena
    End Function
End Class

Public Class Clasification

    Private CCs As List(Of ClasificationConcept)

    Protected model As ModelACoAR

    Public Sub New()
        CCs = New List(Of ClasificationConcept)
    End Sub

    Public Sub setModel(ByVal m As ModelACoAR)
        model = m
    End Sub

    Public Sub CreateClasification(ByVal cluster As vector)
        Dim resources As List(Of Resource) = model.getResources("converged")

        For Each e In model.C.values
            Dim newCC As New ClasificationConcept
            CCs.Add(newCC)
        Next

        For i As Integer = 0 To resources.Count - 1
            Dim ccID As Integer = cluster.getValue(i) - 1
            CCs(ccID).add(resources(i))
        Next
    End Sub


    Public Function getClassified(ByVal cID As Integer) As List(Of Resource)
        Return CCs(cID - 1).classifiedResources
    End Function

    Public Function getClassificationConcept(ByVal conceptName As String) As ClasificationConcept
        For Each cc As ClasificationConcept In CCs
            If cc.getConceptName = conceptName Then
                Return cc
                Exit Function
            End If
        Next
        Return Nothing
    End Function

    Public Function getClassifiedAt(ByVal r As Resource) As Integer
        For Each cc As ClasificationConcept In CCs
            If cc.classifiedResources.Contains(r) Then
                Return CCs.IndexOf(cc) + 1
                Exit Function
            End If
        Next
        Return Nothing
    End Function

    Public Function getConcepts() As List(Of ClasificationConcept)
        Return CCs
    End Function

    Public Sub add(ByVal cID As Integer, ByVal r As Resource)
        CCs(cID - 1).add(r)
    End Sub

    Public Sub drop(ByVal r As Resource)
        For Each cc As ClasificationConcept In CCs
            If cc.classifiedResources.Contains(r) Then
                cc.classifiedResources.Remove(r)
            End If
        Next
    End Sub
End Class
