﻿Public MustInherit Class Classifier

    Protected model As ModelACoAR

    Public Sub setModel(ByVal m As ModelACoAR)
        model = m
    End Sub

    Public MustOverride Sub classify(ByVal r As Resource)

    Public MustOverride Function isCorrectlyClassified(ByVal r As Resource) As Boolean

End Class

Public Class ClassifierDelta
    Inherits Classifier

    Private threshold As Double
    Private measure As SimilarityMeasure

    Public Sub setThreshold(ByVal n As Double)
        threshold = n
    End Sub

    Public Sub setSimilarityMeasure(ByVal m As SimilarityMeasure)
        measure = m
    End Sub

    Public Overrides Sub classify(ByVal r As Resource)

    End Sub

    Public Overrides Function isCorrectlyClassified(ByVal r As Resource) As Boolean
        Dim sims(0 To model.C.length - 1) As Double
        Dim ccand As Integer = 1
        Dim k As Integer = 0
        Dim index As Integer = model.R.IndexOf(r)

        For Each c As Integer In model.C.values
            sims(k) = measure.similarity(model.VR(index).values, model.VC(c - 1).values)
            If sims(k) >= sims(ccand - 1) Then
                ccand = c
            End If
            k += 1
        Next

        Array.Sort(sims)
        Array.Reverse(sims)
        Dim delta As Double = sims.GetValue(0) - sims.GetValue(1)
        Dim concept As Integer = model.Z.getClassifiedAt(r)

        Return concept = ccand And delta >= threshold
    End Function
End Class