﻿Public MustInherit Class IDictionaryStrategy

    Protected model As ModelACoAR

    Public Sub setModel(ByVal m As ModelACoAR)
        model = m
    End Sub

    Public MustOverride Sub create()

    Public MustOverride Function inDictionary(ByVal t As Tag) As Boolean

    Public MustOverride Sub updateVSM(ByVal tg As Tagging)

    Public MustOverride Sub createVrRepresentation(ByVal r As Resource)

    Public MustOverride Sub createVdRepresentation(ByVal d As Tag)

    Public MustOverride Sub createVcRepresentation()

    Public MustOverride Sub update()

End Class

Public Class DictionaryNAnnotations
    Inherits IDictionaryStrategy

    Private mina As Integer

    Public Sub setMina(ByVal x As Integer)
        mina = x
    End Sub

    Public Overrides Sub create()
        model.D = New List(Of Tag)
        model.VR = New List(Of vector)
        model.VD = New List(Of vector)

        For Each t As Tag In model.T
            If model.getAnnotations(t) >= mina Then
                model.D.Add(t)
            End If
        Next

        For Each r As Resource In model.R
            createVrRepresentation(r)
        Next

        For Each d As Tag In model.D
            createVdRepresentation(d)
        Next

    End Sub

    Public Overrides Sub createVcRepresentation()

        model.VC = New List(Of vector)
        For Each cc As ClasificationConcept In model.Z.getConcepts
            Dim vcrep As New vector
            vcrep.redimVector(model.D.Count)
            For Each r As Resource In cc.classifiedResources
                Dim index As Integer = model.R.IndexOf(r)
                Dim vrrep As vector = model.VR(index)
                vector.vector_sum(vcrep, vrrep)
            Next
            model.VC.Add(vcrep)
        Next

    End Sub

    Public Overrides Sub createVdRepresentation(ByVal d As Tag)
        Dim v As New vector
        v.redimVector(model.D.Count)
        Dim index As Integer = model.D.IndexOf(d)
        v.setValue(1, index)
        model.VD.Add(v)
    End Sub

    Public Overrides Sub createVrRepresentation(ByVal r As Resource)
        Dim v As New vector
        For Each d As Tag In model.D
            v.add(model.getAnnotations(d, r))
        Next
        model.VR.Add(v)
    End Sub

    Public Overrides Function inDictionary(ByVal t As Tag) As Boolean
        Return model.D.Contains(t)
    End Function

    Public Overrides Sub updateVSM(ByVal tg As Tagging)

        Dim indexR As Integer = model.R.IndexOf(tg.r)
        Dim indexT As Integer = model.D.IndexOf(tg.t)
        If tg.type = "create" Then
            'Si añadimos una etiqueta aumentamos en uno su valor correspondiente en el vector VR del recurso
            Dim myVR As vector = model.VR(indexR)
            myVR.setValue(myVR.getValue(indexT) + 1, indexT)
        Else
            'Si eliminamos una etiqueta disminuimos en uno su valor correspondiente en el vector VR del recurso
            Dim myVR As vector = model.VR(indexR)

            If myVR.getValue(indexT) - 1 > 0 Then
                myVR.setValue(myVR.getValue(indexT) - 1, indexT)
            Else
                myVR.setValue(0, indexT)
            End If
        End If

    End Sub

    Public Overrides Sub update()

        Dim nuevas As New List(Of Tag)

        For Each mytag As Tag In model.T
            If Not inDictionary(mytag) Then
                If model.getAnnotations(mytag) >= mina Then
                    model.D.Add(mytag)
                    nuevas.Add(mytag)
                End If
            End If
        Next

        For Each r As Resource In model.R
            Dim rvector As vector = model.VR.ElementAt(model.R.IndexOf(r))
            Dim c As Integer = model.Z.getClassifiedAt(r)
            Dim cvector As vector = model.VC.ElementAt(c - 1)
            cvector.add(0)
            For Each d As Tag In nuevas
                rvector.add(model.getAnnotations(d, r))
                If r.state = "classified" Then
                    cvector.setValue(cvector.getValue(cvector.values.Length - 1) + model.getAnnotations(d, r), cvector.values.Length - 1)
                End If
            Next
        Next

        For Each d In nuevas
            Dim dvector As New vector
            dvector.redimVector(model.D.Count)
            dvector.setValue(1, model.D.IndexOf(d))
            model.VD.Add(dvector)
        Next
    End Sub


End Class
