﻿Public MustInherit Class IMergingSplittingStrategy
    Protected model As ModelACoAR

    Public Sub setModel(ByVal m As ModelACoAR)
        model = m
    End Sub

    Public MustOverride Sub process()

End Class


Public Class MergingSimilar
    Inherits IMergingSplittingStrategy
    Private threshold As Double
    Private measure As SimilarityMeasure

    Public Sub setThreshold(ByVal n As Double)
        threshold = n
    End Sub

    Public Sub setSimilarityMeasure(ByVal m As SimilarityMeasure)
        measure = m
    End Sub

    Public Overrides Sub process()
        For Each c1 As Integer In model.C.values
            For Each c2 As Integer In model.C.values
                If c1 <> c2 Then
                    If measure.similarity(model.VC(c1 - 1).values, model.VC(c2 - 1).values) >= threshold Then
                        For Each r As Resource In model.Z.getClassified(c2)
                            model.Z.drop(r)
                            model.Z.add(c1, r)
                        Next
                        Dim indexOfc2 As Integer = model.C.searchFor(c2)
                        model.C.drop(indexOfc2)
                    End If
                End If
            Next
        Next
    End Sub

End Class