﻿Public MustInherit Class ISimilaritiesStrategy
    Protected model As ModelACoAR
    Protected measure As SimilarityMeasure

    Public Sub setModel(ByVal m As ModelACoAR)
        model = m
    End Sub

    Public Sub setSimilarityMeasure(ByVal m As SimilarityMeasure)
        measure = m
    End Sub

    Public MustOverride Sub calcSimilaritiesRR()
    Public MustOverride Sub calcSimilaritiesCC()
    Public MustOverride Sub calcSimilaritiesCR()
    Public MustOverride Sub calcSimilaritiesCD()
End Class

Public Class Similarities
    Inherits ISimilaritiesStrategy

    Public Overrides Sub calcSimilaritiesRR()
        Dim N As Integer
        N = model.getResources("classified").Count
        Dim sims(N, N) As Double

        For i As Integer = 0 To N - 1
            For j As Integer = 0 To N - 1
                If i = j Then
                    sims(i, j) = 1
                Else
                    sims(i, j) = measure.similarity(model.VR(i).values, model.VR(j).values)
                End If
            Next
        Next

        model.SRR = sims
    End Sub

    Public Overrides Sub calcSimilaritiesCC()
        Dim N As Integer
        N = model.VC.Count
        Dim sims(N, N) As Double

        For i As Integer = 0 To N - 1
            For j As Integer = 0 To N - 1
                If i = j Then
                    sims(i, j) = 1
                Else
                    sims(i, j) = measure.similarity(model.VC(i).values, model.VC(j).values)
                End If
            Next
        Next

        model.SCC = sims
    End Sub

    Public Overrides Sub calcSimilaritiesCR()
        Dim filas, columnas As Integer
        filas = model.VC.Count
        columnas = model.VR.Count
        Dim sims(filas, columnas) As Double

        For i As Integer = 0 To filas - 1
            For j As Integer = 0 To columnas - 1
                sims(i, j) = measure.similarity(model.VC(i).values, model.VR(j).values)
            Next
        Next

        model.SCR = sims
    End Sub

    Public Overrides Sub calcSimilaritiesCD()
        Dim filas, columnas As Integer
        filas = model.VC.Count
        columnas = model.VD.Count
        Dim sims(filas, columnas) As Double

        For i As Integer = 0 To filas - 1
            For j As Integer = 0 To columnas - 1
                sims(i, j) = measure.similarity(model.VC(i).values, model.VD(j).values)
            Next
        Next

        model.SCD = sims
    End Sub


End Class