﻿Public Class ModelACoAR

    Private _Modelname As String
    Public Property modelName() As String
        Get
            Return _Modelname
        End Get
        Set(ByVal value As String)
            _Modelname = value
        End Set
    End Property

    Private _A As List(Of Annotation)
    Public Property A() As List(Of Annotation)
        Get
            Return _A
        End Get
        Set(ByVal value As List(Of Annotation))
            _A = value
        End Set
    End Property

    Private _T As List(Of Tag)
    Public Property T() As List(Of Tag)
        Get
            Return _T
        End Get
        Set(ByVal value As List(Of Tag))
            _T = value
        End Set
    End Property

    Private _R As List(Of Resource)
    Public Property R() As List(Of Resource)
        Get
            Return _R
        End Get
        Set(ByVal value As List(Of Resource))
            _R = value
        End Set
    End Property

    'Colección de Diccionario
    Private _D As List(Of Tag)
    Public Property D() As List(Of Tag)
        Get
            Return _D
        End Get
        Set(ByVal value As List(Of Tag))
            _D = value
        End Set
    End Property

    'Vectores de representación
    Private _VR As List(Of vector)
    Public Property VR() As List(Of vector)
        Get
            Return _VR
        End Get
        Set(ByVal value As List(Of vector))
            _VR = value
        End Set
    End Property

    Private _VD As List(Of vector)
    Public Property VD() As List(Of vector)
        Get
            Return _VD
        End Get
        Set(ByVal value As List(Of vector))
            _VD = value
        End Set
    End Property

    Private _VC As List(Of vector)
    Public Property VC() As List(Of vector)
        Get
            Return _VC
        End Get
        Set(ByVal value As List(Of vector))
            _VC = value
        End Set
    End Property

    'Colección de Conceptos de Clasificación
    Private _C As vector
    Public Property C() As vector
        Get
            Return _C
        End Get
        Set(ByVal value As vector)
            _C = value
        End Set
    End Property

    'Clasificación
    Private _Z As Clasification
    Public Property Z() As Clasification
        Get
            Return _Z
        End Get
        Set(ByVal value As Clasification)
            _Z = value
        End Set
    End Property

    'Conjunto de Similaridades

    Private _SRR As Double(,)
    Public Property SRR() As Double(,)
        Get
            Return _SRR
        End Get
        Set(ByVal value As Double(,))
            _SRR = value
        End Set
    End Property

    Private _SCC As Double(,)
    Public Property SCC() As Double(,)
        Get
            Return _SCC
        End Get
        Set(ByVal value As Double(,))
            _SCC = value
        End Set
    End Property

    Private _SCR As Double(,)
    Public Property SCR() As Double(,)
        Get
            Return _SCR
        End Get
        Set(ByVal value As Double(,))
            _SCR = value
        End Set
    End Property

    Private _SCD As Double(,)
    Public Property SCD() As Double(,)
        Get
            Return _SCD
        End Get
        Set(ByVal value As Double(,))
            _SCD = value
        End Set
    End Property
    ''-------------------------------------------------------------''

    Public Sub New(ByVal f As Folksonomy)
        modelName = "MODEL: " & f.folksonomyName
        T = f.tagList
        R = f.resourceList
        A = f.annotationList
        C = New vector
        Z = New Clasification
        Z.setModel(Me)
    End Sub

    Public Function getResourceFromAnnotation(ByVal t As Tag) As Resource
        For Each an As Annotation In A
            If an.tag.Equals(t) Then
                Return an.resource
            End If
        Next
        Return Nothing
    End Function

    Public Function getResources(ByVal s As String) As List(Of Resource)
        Dim l As New List(Of Resource)

        For Each re As Resource In R
            If re.state = s Then
                l.Add(re)
            End If
        Next

        Return l
    End Function

    Public Function getAnnotations(ByVal t As Tag) As Integer
        Dim n As Integer = t.AnnotationsNumber
        Return n
    End Function
    Public Function getAnnotations(ByVal r As Resource) As Integer
        Dim n As Integer = r.AnnotationsNumber
        Return n
    End Function
    Public Function getAnnotations(ByVal t As Tag, ByVal r As Resource) As Integer
        Dim a As Annotation = searchForAnnotation(t, r)
        If a IsNot Nothing Then
            Return a.AnnotationsNumber
        Else
            Return 0
        End If

    End Function

    Public Function getAResource(ByVal idr As Integer) As Resource
        For Each res As Resource In R
            If res.id = idr Then
                Return res
                Exit Function
            End If
        Next
        Return Nothing
    End Function

    Public Function getTag(ByVal idt As Integer) As Tag
        For Each eti As Tag In T
            If eti.tagId = idt Then
                Return eti
                Exit Function
            End If
        Next
        Return Nothing
    End Function

    Public Function searchForAnnotation(ByVal t As Tag, ByVal r As Resource) As Annotation
        For Each an As Annotation In A
            If an.tag.text = t.text And an.resource.id = r.id Then
                Return an
                Exit Function
            End If
        Next
        Return Nothing
    End Function

    'Funciones para la impresion de las colecciones del modelo ACoAR

    Public Sub modelNamePrint(ByVal tb As TextBlock)
        Printer.printvbCrLf(tb, modelName)
    End Sub

    Public Sub annotationsPrint(ByVal tb As TextBlock)
        For Each An As Annotation In A
            Printer.printvbCrLf(tb, An.ToString)
        Next
    End Sub

    Public Sub resourcesPrint(ByVal tb As TextBlock)
        For Each res As Resource In R
            Printer.printvbCrLf(tb, res.toString)
        Next
    End Sub

    Public Sub tagsPrint(ByVal tb As TextBlock)
        For Each ta As Tag In T
            Printer.printvbCrLf(tb, ta.toString)
        Next
    End Sub

    Public Sub dictionaryPrint(ByVal tb As TextBlock)
        For Each t As Tag In D
            Printer.printvbCrLf(tb, t.toString)
        Next
    End Sub

    Public Sub VRPrint(ByVal tb As TextBlock)
        For x As Integer = 1 To VR.Count
            Printer.printvbCrLf(tb, "R" + x.ToString + ": " + VR(x - 1).ToString)
        Next
    End Sub

    Public Sub VDPrint(ByVal tb As TextBlock)
        For x As Integer = 1 To VD.Count
            Printer.printvbCrLf(tb, "d" + x.ToString + ": " + VD(x - 1).ToString)
        Next
    End Sub

    Public Sub VCPrint(ByVal tb As TextBlock)
        For x As Integer = 1 To VC.Count
            Printer.printvbCrLf(tb, "VC(" + x.ToString + ") : " + VC(x - 1).ToString)
        Next
    End Sub

    Public Sub CcPrint(ByVal tb As TextBlock)
        For x As Integer = 1 To C.length
            Printer.printvbCrLf(tb, "C" + x.ToString + ": " + C.getValue(x - 1).ToString)
        Next
    End Sub

    Public Sub ClassificationPrint(ByVal tb As TextBlock)
        For Each cc As ClasificationConcept In Z.getConcepts
            Printer.printvbCrLf(tb, "C" + (Z.getConcepts.IndexOf(cc) + 1).ToString + " : " + cc.ToString)
        Next
    End Sub

    Public Sub SRRPrint(ByVal tb As TextBlock)
        Printer.print(tb, SRR)
    End Sub

    Public Sub SCCPrint(ByVal tb As TextBlock)
        Printer.print(tb, SCC)
    End Sub

    Public Sub SCRPrint(ByVal tb As TextBlock)
        Printer.print(tb, SCR)
    End Sub

    Public Sub SCDPrint(ByVal tb As TextBlock)
        Printer.print(tb, SCD)
    End Sub
End Class