﻿'int LevenshteinDistance(char str1[1..lenStr1], char str2[1..lenStr2])
'   // d is a table with lenStr1+1 rows and lenStr2+1 columns
'   declare int d[0..lenStr1, 0..lenStr2]
'   // i and j are used to iterate over str1 and str2
'   declare int i, j, cost

'   for i from 0 to lenStr1
'       d[i, 0] := i
'   for j from 0 to lenStr2
'       d[0, j] := j

'   for i from 1 to lenStr1
'       for j from 1 to lenStr2
'           if str1[i] = str2[j] then cost := 0
'                                else cost := 1
'           d[i, j] := minimum(
'                                d[i-1, j] + 1,     // deletion
'                                d[i, j-1] + 1,     // insertion
'                                d[i-1, j-1] + cost   // substitution
'                            )

'   return d[lenStr1, lenStr2]

Public Class levenshteinDistance


    Public Shared Function distance(ByVal s1 As String, ByVal s2 As String) As Integer
        Dim coste As Integer = 0
        Dim n1 As Integer = s1.Length
        Dim n2 As Integer = s2.Length
        Dim m As Integer(,) = New Integer(n1, n2) {}
        For i As Integer = 0 To n1
            m(i, 0) = i
        Next
        For i As Integer = 1 To n2
            m(0, i) = i
        Next
        For i1 As Integer = 1 To n1
            For i2 As Integer = 1 To n2
                coste = If((s1(i1 - 1) = s2(i2 - 1)), 0, 1)
                m(i1, i2) = Math.Min(Math.Min(m(i1 - 1, i2) + 1, m(i1, i2 - 1) + 1), m(i1 - 1, i2 - 1) + coste)
            Next
        Next
        Return m(n1, n2)
    End Function
End Class