﻿Imports IMaGeProject.Web

Partial Public Class arbol
    Inherits UserControl
    Private MiMediador As Mediador

    Public Sub New()
        InitializeComponent()
    End Sub

    Public Sub conocerMediador(ByVal m As Mediador)
        MiMediador = m
    End Sub

    'Esta función sólo usarla cuando se añade una hija desde la pantalla, no para cargar
    Public Sub añadirHojaHija(ByVal cadena As String, ByVal id As Integer)
        Dim hoja As hojaArbol
        hoja = New hojaArbol(id)
        hoja.textBlockEtiqueta.Text = cadena

        hoja.conocerMediador(MiMediador)

        Dim elemento As New TreeViewItem
        elemento.Header = hoja

        Dim seleccionado As TreeViewItem
        seleccionado = MiTreeView.SelectedItem

        If Not IsNothing(seleccionado) Then
            seleccionado.Items.Add(elemento)
            seleccionado.IsExpanded = True
        Else
            elemento.IsSelected = True
            MiTreeView.Items.Add(elemento)
        End If
    End Sub


    Public Sub añadirHojaIndependiente(ByVal cadena As String, ByVal id As Integer, ByVal color As SolidColorBrush)
        Dim hoja As hojaArbol
        hoja = New hojaArbol(id)
        hoja.textBlockEtiqueta.Text = cadena
        hoja.conocerMediador(MiMediador)

        Dim elemento As New TreeViewItem
        elemento.Header = hoja
        elemento.IsSelected = True

        MiTreeView.Items.Add(elemento)

        hoja.toggleButton.Background = color

    End Sub

    Public Sub eliminarHoja()
        Dim seleccionado As TreeViewItem
        seleccionado = MiTreeView.SelectedItem

        If nivelSuperior(seleccionado) Then
            MiTreeView.Items.Remove(seleccionado)
        Else
            Dim padre As TreeViewItem
            padre = seleccionado.Parent

            padre.Items.Remove(seleccionado)
        End If
    End Sub

    Public Function indicarPadre() As Integer
        Dim seleccionado As TreeViewItem
        seleccionado = MiTreeView.SelectedItem

        If Not IsNothing(seleccionado) Then
            Dim hoja As hojaArbol
            hoja = seleccionado.Header

            Return hoja.getIdHoja()
        Else
            Return Nothing
        End If
    End Function

    Private Function nivelSuperior(ByVal t As TreeViewItem) As Boolean
        If t.Parent.Equals(MiTreeView) Then
            Return True
        Else
            Return False
        End If
    End Function


    Public Sub limpiarArbol()

        If MiTreeView.Items.Count > 0 Then
            For index As Integer = MiTreeView.Items.Count - 1 To 0 Step -1
                Dim elemento As TreeViewItem
                elemento = MiTreeView.Items(index)
                MiTreeView.Items.Remove(elemento)
            Next
        End If
    End Sub

    'Se cargan las etiquetas del árbol, tanto al principio de la aplicación como cuando cambiamos de imagen
    Public Sub cargarArbol(ByVal idImagen As Integer)
        'Buscamos las etiquetas de la imagen seleccionada
        Dim query4 = (From etiquetaEntera In Stado.cntxtIMaGe.EtiquetasImagens Where etiquetaEntera.IdImagen = idImagen AndAlso etiquetaEntera.Padre = 0 Select etiquetaEntera)

        For index As Integer = 0 To query4.Count - 1

            'Buscamos el nombre de la etiqueta
            Dim idEtiqQuery As New Integer
            idEtiqQuery = query4.ElementAt(index).IdEtiqueta
            Dim query5 = (From etiquetaNombre In Stado.cntxtIMaGe.ListadoEtiquetas Where etiquetaNombre.Id = idEtiqQuery Select etiquetaNombre.Nombre)
            Dim colorActual As SolidColorBrush
            colorActual = New SolidColorBrush(Color.FromArgb(Convert.ToByte(query4.ElementAt(index).Color.Substring(1, 2), 16), Convert.ToByte(query4.ElementAt(index).Color.Substring(3, 2), 16), Convert.ToByte(query4.ElementAt(index).Color.Substring(5, 2), 16), Convert.ToByte(query4.ElementAt(index).Color.Substring(7, 2), 16)))

            'Añadir las hojas que no tienen padre primero
            añadirHojaIndependiente(query5.First, query4.ElementAt(index).Id, colorActual)
        Next

        'Cargo las hijas
        cargarArbolHijas(idImagen)

        'MessageBox.Show("Árbol cargado.")
    End Sub

    'Cargarmos las hijas
    Private Sub cargarArbolHijas(ByVal idImagen As Integer)

        For index2 As Integer = 0 To MiTreeView.Items.Count - 1

            'Cogemos el padre
            Dim elemento As TreeViewItem
            elemento = MiTreeView.Items(index2)
            Dim padreHoja As New hojaArbol
            padreHoja = elemento.Header

            'Buscamos sus hijas
            Dim q = (From etiquetasHijas In Stado.cntxtIMaGe.EtiquetasImagens Where etiquetasHijas.IdImagen = idImagen And etiquetasHijas.Padre = padreHoja.getIdHoja Select etiquetasHijas)

            For index As Integer = 0 To q.Count - 1

                'Añadimos la hoja
                Dim elementoAñadir As New TreeViewItem
                Dim hoja As hojaArbol
                hoja = New hojaArbol(q.ElementAt(index).Id)

                'Buscamos el nombre de la etiqueta
                Dim idEtiqQuery As New Integer
                idEtiqQuery = q.ElementAt(index).IdEtiqueta
                Dim query15 = (From etiquetaNombre In Stado.cntxtIMaGe.ListadoEtiquetas Where etiquetaNombre.Id = idEtiqQuery Select etiquetaNombre.Nombre)
                Dim colorActual As SolidColorBrush
                colorActual = New SolidColorBrush(Color.FromArgb(Convert.ToByte(q.ElementAt(index).Color.Substring(1, 2), 16), Convert.ToByte(q.ElementAt(index).Color.Substring(3, 2), 16), Convert.ToByte(q.ElementAt(index).Color.Substring(5, 2), 16), Convert.ToByte(q.ElementAt(index).Color.Substring(7, 2), 16)))

                hoja.textBlockEtiqueta.Text = query15.First
                hoja.toggleButton.Background = colorActual
                hoja.conocerMediador(MiMediador)
                elementoAñadir.Header = hoja
                elemento.Items.Add(elementoAñadir)
                elemento.IsExpanded = True

                'Buscamos las hijas de dicha hoja
                cargarArbolHijasHija(elemento, idImagen)

            Next
        Next

    End Sub

    'Recursividad
    Private Sub cargarArbolHijasHija(ByVal arbol As TreeViewItem, ByVal idImagen As Integer)
        For index2 As Integer = 0 To arbol.Items.Count - 1

            'Cogemos el padre
            Dim elemento As TreeViewItem
            elemento = arbol.Items(index2)
            Dim padreHoja As New hojaArbol
            padreHoja = elemento.Header

            'Buscamos las hijas
            Dim qq = (From etiquetasHijas In Stado.cntxtIMaGe.EtiquetasImagens Where etiquetasHijas.IdImagen = idImagen And etiquetasHijas.Padre = padreHoja.getIdHoja Select etiquetasHijas)

            For index As Integer = 0 To qq.Count - 1
                If padreHoja.getIdHoja = qq.ElementAt(index).Padre Then 'Hemos encontrado al padre
                    'Añadimos la hoja
                    Dim elementoAñadir As New TreeViewItem
                    Dim hoja As hojaArbol
                    hoja = New hojaArbol(qq.ElementAt(index).Id)

                    'Buscamos el nombre de la etiqueta
                    Dim idEtiqQuery As New Integer
                    idEtiqQuery = qq.ElementAt(index).IdEtiqueta
                    Dim query5 = (From etiquetaNombre In Stado.cntxtIMaGe.ListadoEtiquetas Where etiquetaNombre.Id = idEtiqQuery Select etiquetaNombre.Nombre)
                    Dim colorActual As SolidColorBrush
                    colorActual = New SolidColorBrush(Color.FromArgb(Convert.ToByte(qq.ElementAt(index).Color.Substring(1, 2), 16), Convert.ToByte(qq.ElementAt(index).Color.Substring(3, 2), 16), Convert.ToByte(qq.ElementAt(index).Color.Substring(5, 2), 16), Convert.ToByte(qq.ElementAt(index).Color.Substring(7, 2), 16)))

                    hoja.textBlockEtiqueta.Text = query5.First
                    hoja.toggleButton.Background = colorActual
                    hoja.conocerMediador(MiMediador)
                    elementoAñadir.Header = hoja
                    elemento.Items.Add(elementoAñadir)
                    elemento.IsExpanded = True

                    'Buscamos las hijas de dicha hoja
                    cargarArbolHijasHija(elemento, idImagen)
                End If
            Next
        Next

    End Sub


    'En el arbol, desactiva las hojas que no están dentro del zoom
    Public Sub mostrarEtiquetasDelZoom(ByVal listaEtiquetas As List(Of Etiqueta), ByVal listaCropBox As List(Of Double))
        For index As Integer = 0 To MiTreeView.Items.Count - 1
            Dim elemento As TreeViewItem
            elemento = MiTreeView.Items(index)

            Dim hoja As New hojaArbol
            hoja = elemento.Header

            Dim etiq As Etiqueta
            etiq = MiMediador.buscaEtiqueta(hoja.getIdHoja()) 'Buscamos en la lista de Etiquetas la hoja del TreeView


            If Not entraDentrodelZoom(etiq, listaCropBox) Then
                elemento = MiTreeView.Items(index)

                If hoja.checkBoxEye.IsChecked Then 'Si la etiqueta está activada, la desactivamos porque no pertenece al zoom
                    MiMediador.etiquetaUncheck(hoja.getIdHoja())
                End If
                hoja.IsEnabled = False 'Desactivamos la hoja

            End If

            'Buscamos las hijas
            If elemento.HasItems Then
                MuestraArbol(elemento, listaEtiquetas, listaCropBox)
            End If
        Next
    End Sub

    'Recursividad
    Private Sub MuestraArbol(ByVal arbol As TreeViewItem, ByVal listaEtiquetas As List(Of Etiqueta), ByVal listaCropBox As List(Of Double))
        For index As Integer = 0 To arbol.Items.Count - 1

            Dim elemento As New TreeViewItem
            elemento = arbol.Items(index)
            Dim hoja As New hojaArbol
            hoja = elemento.Header
            Dim etiq As Etiqueta
            etiq = MiMediador.buscaEtiqueta(hoja.getIdHoja()) 'Buscamos en la lista de Etiquetas la hoja del TreeView

            If Not entraDentrodelZoom(etiq, listaCropBox) Then
                If hoja.checkBoxEye.IsChecked Then 'Si la etiqueta está activada, la desactivamos porque no pertenece al zoom
                    MiMediador.etiquetaUncheck(hoja.getIdHoja())
                End If
                hoja.IsEnabled = False 'Desactivamos la hoja
            End If

            'Buscamos las hijas
            If elemento.HasItems Then
                MuestraArbol(elemento, listaEtiquetas, listaCropBox)
            End If
        Next
    End Sub

    'Determina si una etiqueta está dentro del zoom
    Public Function entraDentrodelZoom(ByVal eti As Etiqueta, ByVal lista As List(Of Double)) As Boolean
        Dim width As Double
        Dim height As Double

        width = eti.get_Width * lista.Item(2)
        height = eti.get_Height * lista.Item(3)


        If lista.Item(0) <= eti.get_X And eti.get_Width <= lista.Item(4) Then 'Miramos si el ancho y el left están dentro del zoom
            If lista.Item(1) <= eti.get_Y And eti.get_Height <= lista.Item(5) Then 'Si es así, hacemos lo mismo en vertical
                If (lista.Item(0) + lista.Item(4)) >= (eti.get_X + eti.get_Width) Then 'Miramos para que rectangulo entero está dentro
                    If (lista.Item(1) + lista.Item(5)) >= (eti.get_Y + eti.get_Height) Then
                        Return True
                    Else
                        Return False
                    End If
                Else
                    Return False
                End If
            Else
                'MessageBox.Show("T: " + lista.Item(1).ToString + " - " + eti.get_Y.ToString + ", " + height.ToString + " - " + lista.Item(5).ToString)
                Return False

            End If
        Else
            'MessageBox.Show("L: " + lista.Item(0).ToString + " - " + eti.get_X.ToString + ", " + width.ToString + " - " + lista.Item(4).ToString)
            Return False
        End If
    End Function

    'Si una etiqueta tiene el Check activado, lo quita del visor para hacer el zoom (Temas de escalado)
    Public Sub quitarHojacheck()
        For index As Integer = 0 To MiTreeView.Items.Count - 1
            Dim elemento As TreeViewItem
            elemento = MiTreeView.Items(index)
            Dim hoja As New hojaArbol
            hoja = elemento.Header
            If hoja.checkBoxEye.IsChecked Then
                If hoja.IsEnabled = True Then 'Solo desactivamos las que están activadas, porque las desactivadas les hemos quitado el rectangulo al hacer el zoom
                    MiMediador.etiquetaUncheck(hoja.getIdHoja())
                End If
            End If

            'Buscamos las hijas
            If elemento.HasItems Then
                quitarHojacheckHija(elemento)
            End If
        Next
    End Sub

    'Recursividad
    Private Sub quitarHojacheckHija(ByVal arbol As TreeViewItem)
        For index As Integer = 0 To arbol.Items.Count - 1

            Dim elemento As New TreeViewItem
            elemento = arbol.Items(index)
            Dim hoja As New hojaArbol
            hoja = elemento.Header

            If hoja.checkBoxEye.IsChecked Then
                If hoja.IsEnabled = True Then 'Solo desactivamos las que están activadas, porque las desactivadas les hemos quitado el rectangulo al hacer el zoom
                    MiMediador.etiquetaUncheck(hoja.getIdHoja())
                End If
            End If

            'Buscamos las hijas
            If elemento.HasItems Then
                quitarHojacheckHija(elemento)
            End If
        Next
    End Sub

    'Si una etiqueta tiene el Check activado, lo pone del visor para hacer el zoom (Temas de escalado)
    Public Sub ponerHojacheck()
        For index As Integer = 0 To MiTreeView.Items.Count - 1
            Dim elemento As TreeViewItem
            elemento = MiTreeView.Items(index)
            Dim hoja As New hojaArbol
            hoja = elemento.Header
            If hoja.checkBoxEye.IsChecked Then
                MiMediador.etiquetaCheck(hoja.getIdHoja())
            End If

            'Buscamos las hijas
            If elemento.HasItems Then
                ponerHojacheckHija(elemento)
            End If
        Next
    End Sub

    'Recursividad
    Private Sub ponerHojacheckHija(ByVal arbol As TreeViewItem)
        For index As Integer = 0 To arbol.Items.Count - 1

            Dim elemento As New TreeViewItem
            elemento = arbol.Items(index)
            Dim hoja As New hojaArbol
            hoja = elemento.Header

            If hoja.checkBoxEye.IsChecked Then
                MiMediador.etiquetaCheck(hoja.getIdHoja())
            End If

            'Buscamos las hijas
            If elemento.HasItems Then
                ponerHojacheckHija(elemento)
            End If
        Next
    End Sub

    'Recorre el arbol en busca de hojas desactivadas al darle al botón Reset (Pasar de imagen zoom a la original)
    Public Sub ActivarHojas()
        For index As Integer = 0 To MiTreeView.Items.Count - 1
            Dim elemento As New TreeViewItem
            elemento = MiTreeView.Items(index)

            Dim hoja As New hojaArbol
            hoja = elemento.Header

            If hoja.IsEnabled = False Then
                hoja.IsEnabled = True
            End If

            'Buscamos las hijas
            If elemento.HasItems Then
                ActivaHojaArbol(elemento)
            End If
        Next
    End Sub

    'Recursividad
    Private Sub ActivaHojaArbol(ByVal arbol As TreeViewItem)
        For index As Integer = 0 To arbol.Items.Count - 1

            Dim elemento As New TreeViewItem
            elemento = arbol.Items(index)

            Dim hoja As New hojaArbol
            hoja = elemento.Header

            If hoja.IsEnabled = False Then
                hoja.IsEnabled = True
            End If

            'Buscamos las hijas
            If elemento.HasItems Then
                ActivaHojaArbol(elemento)
            End If
        Next
    End Sub

    'Mirar si la etiqueta está dentro del zoom y el zoom está activado
    Public Sub ponerHojaZoom(ByVal lista As List(Of Double))
        For index As Integer = 0 To MiTreeView.Items.Count - 1
            Dim elemento As TreeViewItem
            elemento = MiTreeView.Items(index)
            Dim hoja As New hojaArbol
            hoja = elemento.Header
            Dim etiq As Etiqueta
            etiq = MiMediador.buscaEtiqueta(hoja.getIdHoja()) 'Buscamos en la lista de Etiquetas la hoja del TreeView

            If entraDentrodelZoom(etiq, lista) Then 'Si la etiqueta está dentro del zoom
                If hoja.IsEnabled = False Then
                    hoja.IsEnabled = True 'Activamos la hoja
                End If
                If hoja.checkBoxEye.IsChecked Then ' Mirar si la hoja tiene el chec activado para activárselo
                    MiMediador.etiquetaCheck(hoja.getIdHoja())
                End If
            Else
                hoja.IsEnabled = False 'Desactivamos la hoja
            End If

            'Buscamos las hijas
            If elemento.HasItems Then
                ponerHojaHijaZoom(elemento, lista)
            End If
        Next
    End Sub

    'Recursividad
    Private Sub ponerHojaHijaZoom(ByVal arbol As TreeViewItem, ByVal lista As List(Of Double))
        For index As Integer = 0 To arbol.Items.Count - 1

            Dim elemento As New TreeViewItem
            elemento = arbol.Items(index)
            Dim hoja As New hojaArbol
            hoja = elemento.Header

            Dim etiq As Etiqueta
            etiq = MiMediador.buscaEtiqueta(hoja.getIdHoja()) 'Buscamos en la lista de Etiquetas la hoja del TreeView

            If entraDentrodelZoom(etiq, lista) Then 'Si la etiqueta está dentro del zoom
                If hoja.IsEnabled = False Then
                    hoja.IsEnabled = True 'Activamos la hoja
                End If
                If hoja.checkBoxEye.IsChecked Then ' Mirar si la hoja tiene el chec activado para activárselo
                    MiMediador.etiquetaCheck(hoja.getIdHoja())
                End If
            Else
                hoja.IsEnabled = False 'Desactivamos la hoja
            End If

            'Buscamos las hijas
            If elemento.HasItems Then
                ponerHojaHijaZoom(elemento, lista)
            End If
        Next
    End Sub

End Class
