﻿Imports System.Windows.Printing

Partial Public Class barraDeHerramientas
    Inherits UserControl
    Private MiMediador As Mediador

    Public Sub New()
        InitializeComponent()
        Me.ocultarBotonZoom()
        Me.ocultarBotonReset()
        Me.ocultarBotonMover()
        Me.ocultarBotonEtiquetar()
    End Sub

    Public Sub conocerMediador(ByVal m As Mediador)
        MiMediador = m
    End Sub

    'Limpiar el visor
    Private Sub Button_limpiar_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles Button_limpiar.Click
        MiMediador.limpiarVisor()
        If MiMediador.EstaZoomActivado Then
            MiMediador.DesactivarEtiquetado()
            'Poner los botones azules otra vez
            Me.Button_Etiquetar.Background = Me.Button_limpiar.Background
            Me.Button_Etiquetar.BorderBrush = Me.Button_limpiar.BorderBrush
            Me.Button_Mover.Background = Me.Button_limpiar.Background
            Me.Button_Mover.BorderBrush = Me.Button_limpiar.BorderBrush
        Else
            ocultarBotonZoom()
        End If
        MiMediador.ponerCursorOriginal()
        MiMediador.eliminarMovimientos()
        MiMediador.desactivarPanelNuevaEtiqueta()
        Button_limpiar.Visibility = Windows.Visibility.Collapsed
    End Sub

    'Hacer Zoom
    Private Sub Button_Zoom_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles Button_Zoom.Click
        mostrarBotonMover()
        ocultarBotonLimpiar()
        MiMediador.quitarCheck()
        MiMediador.llamaZoom()
        MiMediador.ponerCheck()
        MiMediador.mostrarEtiquetasZoom()
        MiMediador.limpiarVisor()
    End Sub

    'Mostrar imagen original
    Public Sub Button_Reset_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles Button_Reset.Click
        Me.ocultarBotonReset() 'Ocultamos los botones
        Me.ocultarBotonMover()
        Me.ocultarBotonEtiquetar()
        MiMediador.ActivarEtiquetado() 'Activar otra vez el etiquetado en el visor
        MiMediador.eliminarMovimientos() 'Eliminar los movimientos del Botón Mover
        MiMediador.ponerCursorOriginal()
        MiMediador.quitarCheck()
        MiMediador.ponerHojasActivas()
        MiMediador.mostrarImagenOriginal()
        MiMediador.ponerCheck()
        MiMediador.limpiarVisor()
        'Poner los botones azules otra vez
        Me.Button_Etiquetar.Background = Me.Button_limpiar.Background
        Me.Button_Etiquetar.BorderBrush = Me.Button_limpiar.BorderBrush
        Me.Button_Mover.Background = Me.Button_limpiar.Background
        Me.Button_Mover.BorderBrush = Me.Button_limpiar.BorderBrush
    End Sub

    'Mover la imagen cuando el zoom está activado
    Private Sub Button_Mover_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles Button_Mover.Click
        Me.mostrarBotonEtiquetar()
        MiMediador.ponerIconoMano()
        MiMediador.DesactivarEtiquetado()
        MiMediador.limpiarVisor()
        'Mostrar que el movimiento está activado, esto se hace para diferenciar del etiquetado
        Me.Button_Mover.Background = New SolidColorBrush(Colors.Red)
        Me.Button_Mover.BorderBrush = New SolidColorBrush(Colors.Red)
        Me.Button_Etiquetar.Background = Me.Button_limpiar.Background
        Me.Button_Etiquetar.BorderBrush = Me.Button_limpiar.BorderBrush
    End Sub

    'Etiquetar la imagen
    Private Sub Button_Etiquetar_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles Button_Etiquetar.Click
        MiMediador.ActivarEtiquetado()
        MiMediador.ponerCursorOriginal()
        MiMediador.eliminarMovimientos() 'Eliminar los movimientos del Botón Mover
        'Mostrar que el etiquetado está activado, esto se hace para diferenciar del mover imagen
        Me.Button_Etiquetar.Background = New SolidColorBrush(Colors.Red)
        Me.Button_Etiquetar.BorderBrush = New SolidColorBrush(Colors.Red)
        Me.Button_Mover.Background = Me.Button_limpiar.Background
        Me.Button_Mover.BorderBrush = Me.Button_limpiar.BorderBrush
    End Sub


    'Boton Mover
    Private Sub mostrarBotonMover()
        Me.Button_Mover.Visibility = Visibility.Visible
    End Sub

    Private Sub ocultarBotonMover()
        Me.Button_Mover.Visibility = Visibility.Collapsed
    End Sub

    'Boton de Zoom
    Public Sub mostrarBotonZoom()
        Me.Button_Zoom.Visibility = Visibility.Visible
    End Sub

    Public Sub ocultarBotonZoom()
        Me.Button_Zoom.Visibility = Visibility.Collapsed
    End Sub

    'Boton Reset
    Public Sub mostrarBotonReset()
        Me.Button_Reset.Visibility = Visibility.Visible
    End Sub

    Public Sub ocultarBotonReset()
        Me.Button_Reset.Visibility = Visibility.Collapsed
    End Sub

    'Boton Etiquetar
    Private Sub mostrarBotonEtiquetar()
        Me.Button_Etiquetar.Visibility = Visibility.Visible
    End Sub

    Private Sub ocultarBotonEtiquetar()
        Me.Button_Etiquetar.Visibility = Visibility.Collapsed
    End Sub

    'Limpiar el visor
    Public Sub mostrarBotonLimpiar()
        Button_limpiar.Visibility = Visibility.Visible
    End Sub

    Public Sub ocultarBotonLimpiar()
        Button_limpiar.Visibility = Visibility.Collapsed
    End Sub

    'Cuando cambiar la imagen de la galeria, para que la barra de herramientas salga bien.
    Public Sub CambioDeImagenEnBarra()
        ocultarBotonZoom()
        ocultarBotonReset()
        ocultarBotonEtiquetar()
        ocultarBotonMover()
        ocultarBotonLimpiar()
        'Si el boton de mover está activado, le quitamos el movimiento y le ponemos el cursor original
        MiMediador.eliminarMovimientos()
        MiMediador.ponerCursorOriginal()
        MiMediador.ActivarEtiquetado()
        'Poner los botones azules otra vez
        Me.Button_Etiquetar.Background = Me.Button_limpiar.Background
        Me.Button_Etiquetar.BorderBrush = Me.Button_limpiar.BorderBrush
        Me.Button_Mover.Background = Me.Button_limpiar.Background
        Me.Button_Mover.BorderBrush = Me.Button_limpiar.BorderBrush
    End Sub

End Class
