﻿Imports System.ServiceModel.DomainServices.Client
Imports IMaGeProject.Web

Partial Public Class hojaArbol
    Inherits UserControl

    Private MiMediador As Mediador
    Private ColorRectangulo As SolidColorBrush
    Private id As Integer

#Region "SelectedColor DP"
    Public Property SelectedColor() As SolidColorBrush
        Get
            Return DirectCast(GetValue(SelectedColorProperty), SolidColorBrush)
        End Get
        Set(ByVal value As SolidColorBrush)
            SetValue(SelectedColorProperty, value)
        End Set
    End Property

    Public Shared ReadOnly SelectedColorProperty As DependencyProperty = DependencyProperty.Register("SelectedColor", GetType(SolidColorBrush), GetType(hojaArbol), Nothing)
#End Region


    Public Sub New(ByVal id_ As Integer)
        InitializeComponent()
        Dim myBrush = New SolidColorBrush()
        myBrush.Color = Colors.Red
        ColorRectangulo = myBrush
        toggleButton.Background = myBrush
        Me.id = id_
    End Sub

    'Para el escalado, quitarHojaCheck etc...
    Public Sub New()
        InitializeComponent()
        Dim myBrush = New SolidColorBrush()
        myBrush.Color = Colors.Red
        ColorRectangulo = myBrush
        toggleButton.Background = myBrush

    End Sub


    Public Sub conocerMediador(ByVal m As Mediador)
        MiMediador = m
    End Sub

    Private Sub buttonX_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles buttonX.Click
        Dim query13 = (From etiquetaVotos In Stado.cntxtIMaGe.EtiquetasImagens Where etiquetaVotos.Id = id Select etiquetaVotos)

        If query13.First.Votos = 1 Then
            MiMediador.eliminarHoja(id)
        Else
            query13.First.Votos = query13.First.Votos - 1
            Stado.cntxtIMaGe.SubmitChanges(AddressOf OnSubmitCompletedEliminar, Nothing)
        End If

        Dim t As Tag = MyModel.model.getTag(query13.First.IdEtiqueta)
        Dim r As Resource = MyModel.model.getAResource(query13.First.IdImagen)
        Dim tg As New Tagging(r, t, "delete")
        MyModel.ACoAR.ModelACoAR_Evolution(tg)

    End Sub

    Private Sub checkBoxEye_Checked(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles checkBoxEye.Checked
        MiMediador.etiquetaCheck(id)
    End Sub

    Private Sub checkBoxEye_Unchecked(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles checkBoxEye.Unchecked
        MiMediador.etiquetaUncheck(id)
    End Sub

    Private Sub LayoutRoot_MouseEnter(ByVal sender As System.Object, ByVal e As System.Windows.Input.MouseEventArgs) Handles LayoutRoot.MouseEnter
        MiMediador.etiquetaHojaMouseEnter(id)
    End Sub

    Private Sub LayoutRoot_MouseLeave(ByVal sender As System.Object, ByVal e As System.Windows.Input.MouseEventArgs) Handles LayoutRoot.MouseLeave
        If checkBoxEye.IsChecked Then
            MiMediador.etiquetaHojaMouseLeave(id)
        Else
            MiMediador.etiquetaUncheck(id)
        End If
    End Sub

    Public Function getIdHoja() As Integer
        Return id
    End Function

    'Elegimos el color de la etiqueta y ponemos el color en el botón
#Region "Color Click"
    Private Sub Color_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        Dim btn As Button = TryCast(sender, Button)
        Me.SelectedColor = TryCast(btn.Background, SolidColorBrush)
        ColorRectangulo = Me.SelectedColor
        toggleButton.Background = ColorRectangulo
        popUp.IsOpen = False

        If checkBoxEye.IsChecked Then
            Me.checkBoxEye_Unchecked(sender, e)
        End If
        'Llamamos para que el color del rectangulo de la etiqueta cambie
        MiMediador.llamaACambiarColor(id, ColorRectangulo)

        If checkBoxEye.IsChecked Then
            Me.checkBoxEye_Checked(sender, e)
        End If
    End Sub
#End Region

    Private Sub ButtonVotar_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles ButtonVotar.Click

        'Añadimos el voto a la base de datos
        Dim query24 = (From etiquetaEntera In Stado.cntxtIMaGe.EtiquetasImagens Where etiquetaEntera.Id = id Select etiquetaEntera)
        query24.First.Votos = query24.First.Votos + 1
        Stado.cntxtIMaGe.SubmitChanges(AddressOf OnSubmitCompleted, Nothing)

        'Buscamos la anotación y aumentamos en uno su voto.
        'Hay que aumentar el numero de anotaciones de la etiqueta y del recurso
        Dim t As Tag = MyModel.model.getTag(query24.First.IdEtiqueta)
        Dim r As Resource = MyModel.model.getAResource(query24.First.IdImagen)
        t.increaseAnnotations()
        r.increaseAnnotations()
        Dim a As Annotation = MyModel.model.searchForAnnotation(t, r)
        a.increaseAnnotations()

        'Creamos una instancia de Tagging
        Dim tg As New Tagging(r, t, "create")
        MyModel.ACoAR.ModelACoAR_Evolution(tg)
    End Sub

    Private Sub OnSubmitCompleted(ByVal so As SubmitOperation)
        If (so.HasError) Then
            MessageBox.Show(String.Format("Submit Failed: {0}", so.Error.Message))
            so.MarkErrorAsHandled()
        Else
            'Cambiamos el botón por el número de votos recibido por la etiqueta
            Dim query25 = (From votos In Stado.cntxtIMaGe.EtiquetasImagens Where votos.Id = id Select votos.Votos)
            If query25.First Is Nothing Then
                ButtonVotar.Content = 1
            Else
                ButtonVotar.Content = query25.First.ToString
            End If

            ButtonVotar.IsEnabled = False
            buttonX.IsEnabled = False
        End If

    End Sub

    Private Sub OnSubmitCompletedEliminar(ByVal so As SubmitOperation)
        If (so.HasError) Then
            MessageBox.Show(String.Format("Submit Failed: {0}", so.Error.Message))
            so.MarkErrorAsHandled()

        Else
            'Cambiamos el botón por el número de votos recibido por la etiqueta
            Dim query25 = (From votos In Stado.cntxtIMaGe.EtiquetasImagens Where votos.Id = id Select votos.Votos)
            ButtonVotar.Content = query25.First.ToString
            ButtonVotar.IsEnabled = False
            buttonX.IsEnabled = False
        End If

    End Sub
End Class
