﻿Imports IMaGeProject.Web
Imports System.ServiceModel.DomainServices.Client


Partial Public Class panelNuevaEtiqueta
    Inherits UserControl

    Private marcaAgua, marcaAgua2 As Boolean
    Private MiMediador As Mediador
    Private etiquetaUsada As New Boolean 'Cuando eliminamos las etiquetas, para saber si podemos borrar la etiqueta o no (tema de las hijas)

    Public Sub New()
        InitializeComponent()
        marcaAgua = True
        marcaAgua2 = True
        etiquetaUsada = True

    End Sub

    Public Sub conocerMediador(ByVal m As Mediador)
        MiMediador = m
    End Sub

    Private Sub ponerMarcaAgua()
        TextBox_nuevaEtiqueta.Text = "Nombre de la Nueva Etiqueta"
        TextBox_nuevaEtiqueta.FontStyle = FontStyles.Italic
        TextBox_nuevaEtiqueta.Foreground = New SolidColorBrush(Color.FromArgb(&HFF, &H6C, &H86, &H68))
        marcaAgua = True
    End Sub

    Private Sub ponerMarcaAgua2()
        tb_nuevaEtiquetajerarquia.Text = "Nombre de la Nueva Etiqueta"
        tb_nuevaEtiquetajerarquia.FontStyle = FontStyles.Italic
        tb_nuevaEtiquetajerarquia.Foreground = New SolidColorBrush(Color.FromArgb(&HFF, &H6C, &H86, &H68))
        marcaAgua2 = True
    End Sub

    Private Sub ponerTextoNormal()
        TextBox_nuevaEtiqueta.Text = ""
        TextBox_nuevaEtiqueta.FontStyle = FontStyles.Normal
        TextBox_nuevaEtiqueta.Foreground = New SolidColorBrush(Colors.Black)
        marcaAgua = False
    End Sub

    Private Sub ponerTextoNormal2()
        tb_nuevaEtiquetajerarquia.Text = ""
        tb_nuevaEtiquetajerarquia.FontStyle = FontStyles.Normal
        tb_nuevaEtiquetajerarquia.Foreground = New SolidColorBrush(Colors.Black)
        marcaAgua2 = False
    End Sub

    Private Sub TextBox_nuevaEtiqueta_GotFocus(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles TextBox_nuevaEtiqueta.GotFocus
        If marcaAgua Then
            ponerTextoNormal()
        End If
    End Sub


    Private Sub Button_añadir_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles Button_añadir.Click
        If marcaAgua Or TextBox_nuevaEtiqueta.Text = "" Then
            MessageBox.Show("No ha introducido ningún nombre para la etiqueta.")
        Else

            'Mirar si la etiqueta que ha añadido pertenece a la lista de etiquetas o no
            Dim etiquetaSelecionada As String
            etiquetaSelecionada = TextBox_nuevaEtiqueta.Text
            Dim query12 = (From EtiquetaExiste In Stado.cntxtIMaGe.ListadoEtiquetas Where EtiquetaExiste.Nombre = etiquetaSelecionada Select EtiquetaExiste)

            If query12.Count = 0 Then 'No ha encontrado ninguna etiqueta que se llame así
                'Ponemos un alert por si la quiere añadir a la lista de las etiquetas
                'Dim seleccion As MessageBoxResult = MessageBox.Show("¿Desea añadir la etiqueta a la lista de etiquetas?", "Etiqueta no encontrada", MessageBoxButton.OKCancel)
                Dim seleccion As MessageBoxResult = MessageBox.Show("La etiqueta introducida no está en la base de datos. Si desea, puede añadir dicha etiqueta en el panel de la jerarquía.", "Etiqueta no encontrada", MessageBoxButton.OK)
            Else 'La etiqueta está en la base de datos
                Dim myBrush = New SolidColorBrush()
                myBrush.Color = Colors.Red
                MiMediador.nuevaEtiqueta(TextBox_nuevaEtiqueta.Text, RadioButton_seleccionado.IsChecked, myBrush)
                RemoveHandler arbolEtiquetas.SelectedItemChanged, AddressOf arbolEtiquetas_SelectedItemChanged
                ponerMarcaAgua()

                MiMediador.limpiarVisor()
                MiMediador.desactivarPanelNuevaEtiqueta()
                MiMediador.ocultarBotonLimpiar()
                MiMediador.ocultarBotonZoom()

                AddHandler arbolEtiquetas.SelectedItemChanged, AddressOf arbolEtiquetas_SelectedItemChanged
            End If


        End If
    End Sub

    'Cargar el árbol de etiquetas
    Private Sub CargarArbolDeEtiquetas()
        Dim contador As Integer
        contador = ListadoEtiquetasDomainDataSource.DataView.Count

        For index As Integer = 0 To contador - 1
            Dim etiqArbol As New TreeViewItem
            Dim etiq As New ListadoEtiquetas
            Dim hojaEtiq As New HojaEtiqueta
            etiq = ListadoEtiquetasDomainDataSource.DataView.Item(index)
            If etiq.Padre.Equals(Nothing) Then
                hojaEtiq.nombre = etiq.Nombre
                hojaEtiq.id = etiq.Id
                hojaEtiq.PonerNombre(etiq.Nombre)
                hojaEtiq.LabelEtiquetaNombre.Foreground = New SolidColorBrush(Colors.Black)

                'Poner el tamaño minimo en la hoja de etiqueta
                Dim textBlock As New TextBlock()
                textBlock.Text = etiq.Nombre
                textBlock.FontSize = textBlock.FontSize
                textBlock.Measure(New Size(Double.PositiveInfinity, Double.PositiveInfinity))
                Dim actualSize As New Size(textBlock.ActualWidth, textBlock.ActualHeight)
                hojaEtiq.Width = actualSize.Width

                etiqArbol.Header = hojaEtiq
                arbolEtiquetas.Items.Add(etiqArbol)
                etiqArbol.IsSelected = True
                etiqArbol.IsExpanded = True
                CargarArbolDeEtiquetasHijas(etiq.Id, etiqArbol, contador)
            End If
        Next
    End Sub

    Private Sub CargarArbolDeEtiquetasHijas(ByVal padreId As Integer, ByVal arbol As TreeViewItem, ByVal contador As Integer)

        For index As Integer = 0 To contador - 1

            Dim etiq As New ListadoEtiquetas
            Dim hija As New TreeViewItem
            Dim hojaEtiq As New HojaEtiqueta

            etiq = ListadoEtiquetasDomainDataSource.DataView.Item(index)
            If etiq.Padre = padreId Then
                hojaEtiq.nombre = etiq.Nombre
                hojaEtiq.id = etiq.Id
                hojaEtiq.PonerNombre(etiq.Nombre)
                hojaEtiq.LabelEtiquetaNombre.Foreground = New SolidColorBrush(Colors.Black)

                'Poner el tamaño minimo en la hoja de etiqueta
                Dim textBlock As New TextBlock()
                textBlock.Text = etiq.Nombre
                textBlock.FontSize = textBlock.FontSize
                textBlock.Measure(New Size(Double.PositiveInfinity, Double.PositiveInfinity))
                Dim actualSize As New Size(textBlock.ActualWidth, textBlock.ActualHeight)
                hojaEtiq.Width = actualSize.Width

                hija.Header = hojaEtiq
                hija.IsSelected = True
                hija.IsExpanded = True

                arbol.Items.Add(hija)
                CargarArbolDeEtiquetasHijas(etiq.Id, hija, contador)
            End If
        Next
    End Sub


    Private Sub ListadoEtiquetasDomainDataSource_LoadedData(ByVal sender As System.Object, ByVal e As System.Windows.Controls.LoadedDataEventArgs) Handles ListadoEtiquetasDomainDataSource.LoadedData
        'Quitamos la función selectedItemChanged del árbol, porque al cargar no funciona bien, y solo se cargaba la primera etiqueta
        RemoveHandler arbolEtiquetas.SelectedItemChanged, AddressOf arbolEtiquetas_SelectedItemChanged

        If e.HasError Then
            System.Windows.MessageBox.Show(e.Error.ToString, "Load Error", System.Windows.MessageBoxButton.OK)
            e.MarkErrorAsHandled()
        Else
            'Cargamos el árbol con todas la etiquetas
            CargarArbolDeEtiquetas()

            'Activamso esa función para que cuando naveguemos por el álbol permita al usuario acceder a las etiquetas desde allí
            AddHandler arbolEtiquetas.SelectedItemChanged, AddressOf arbolEtiquetas_SelectedItemChanged

        End If

    End Sub


    Private Sub TextBox_nuevaEtiqueta_SelectionChanged(ByVal sender As System.Object, ByVal e As System.Windows.Controls.SelectionChangedEventArgs) Handles TextBox_nuevaEtiqueta.SelectionChanged
        Dim eleccion As String
        eleccion = TextBox_nuevaEtiqueta.Text

        BuscarEtiqueta(eleccion)

    End Sub

    'Recorre el arbol en busca de la etiqueta
    Public Sub BuscarEtiqueta(ByVal etiqueta As String)
        For index As Integer = 0 To arbolEtiquetas.Items.Count - 1
            Dim elemento As New TreeViewItem
            elemento = arbolEtiquetas.Items(index)

            If elemento.Header.nombre.Equals(etiqueta) Then
                elemento.IsSelected = True
            Else
                If elemento.IsSelected Then
                    elemento.IsSelected = False
                End If
            End If

            If elemento.HasItems Then
                BuscarEtiquetaHoja(elemento, etiqueta)
            End If
        Next
    End Sub

    'Recursividad
    Private Sub BuscarEtiquetaHoja(ByVal arbol As TreeViewItem, ByVal etiqueta As String)
        For index As Integer = 0 To arbol.Items.Count - 1

            Dim elemento As New TreeViewItem
            elemento = arbol.Items(index)

            If elemento.Header.nombre.Equals(etiqueta) Then
                elemento.IsSelected = True
            Else
                If elemento.IsSelected Then
                    elemento.IsSelected = False
                End If
            End If

            If elemento.HasItems Then
                BuscarEtiquetaHoja(elemento, etiqueta)
            End If
        Next
    End Sub

    Private Sub arbolEtiquetas_SelectedItemChanged(ByVal sender As System.Object, ByVal e As System.Windows.RoutedPropertyChangedEventArgs(Of System.Object)) Handles arbolEtiquetas.SelectedItemChanged

        RemoveHandler TextBox_nuevaEtiqueta.SelectionChanged, AddressOf TextBox_nuevaEtiqueta_SelectionChanged

        'If marcaAgua Then
        '    ponerTextoNormal()
        'End If

        'If marcaAgua2 Then
        '    ponerTextoNormal2()
        'End If

        Dim seleccionado As TreeViewItem
        seleccionado = arbolEtiquetas.SelectedItem
        TextBox_nuevaEtiqueta.FontStyle = FontStyles.Normal
        TextBox_nuevaEtiqueta.Foreground = New SolidColorBrush(Colors.Black)
        marcaAgua = False

        TextBox_nuevaEtiqueta.Text = seleccionado.Header.nombre
        'tb_nuevaEtiquetajerarquia.Text = seleccionado.Header.nombre

        AddHandler TextBox_nuevaEtiqueta.SelectionChanged, AddressOf TextBox_nuevaEtiqueta_SelectionChanged

    End Sub

    Private Sub ButtonAñadirEtiqueta_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles ButtonAñadirEtiqueta.Click
        'Pueden haber etiquetas con el mismo nombre (REQUISITO!!!)

        If marcaAgua2 Or tb_nuevaEtiquetajerarquia.Text = "" Then
            MessageBox.Show("No ha introducido ningún nombre para la etiqueta.")
        Else
            If RadioHija.IsChecked Then 'Añadimos la etiqueta como hija
                Dim seleccionado As TreeViewItem
                seleccionado = arbolEtiquetas.SelectedItem

                Dim etiquetaAñadir As New ListadoEtiquetas
                etiquetaAñadir.Nombre = tb_nuevaEtiquetajerarquia.Text
                etiquetaAñadir.Padre = seleccionado.Header.id

                Stado.cntxtIMaGe.ListadoEtiquetas.Add(etiquetaAñadir)
                Stado.cntxtIMaGe.SubmitChanges(AddressOf OnSubmitCompletedHija, Nothing)

            Else
                'Metemos en la base de datos la etiqueta
                Dim etiquetaIntroducir As New ListadoEtiquetas
                etiquetaIntroducir.Nombre = tb_nuevaEtiquetajerarquia.Text

                Stado.cntxtIMaGe.ListadoEtiquetas.Add(etiquetaIntroducir)
                Stado.cntxtIMaGe.SubmitChanges(AddressOf OnSubmitCompletedIndependiente, Nothing)
            End If

        End If

        
    End Sub

    Private Sub OnSubmitCompletedHija(ByVal so As SubmitOperation)
        If (so.HasError) Then
            MessageBox.Show(String.Format("Submit Failed: {0}", so.Error.Message))
            so.MarkErrorAsHandled()
        Else
            Dim seleccionado As TreeViewItem
            seleccionado = arbolEtiquetas.SelectedItem

            Dim query23 = (From EtiquetaId In Stado.cntxtIMaGe.ListadoEtiquetas Where EtiquetaId.Nombre = tb_nuevaEtiquetajerarquia.Text AndAlso EtiquetaId.Padre = seleccionado.Header.id Select EtiquetaId.Id)

            Dim hojaEtiq As New HojaEtiqueta
            hojaEtiq.nombre = tb_nuevaEtiquetajerarquia.Text
            hojaEtiq.id = query23.First
            hojaEtiq.PonerNombre(hojaEtiq.nombre)

            'Consultamos la id de la etiqueta para crear una instancia y meterla en el modelo ACoAR
            Dim t As New Tag(hojaEtiq.nombre, hojaEtiq.id, 1)
            MyModel.model.T.Add(t)
            'MessageBox.Show("Se ha agregado la etiqueta con ID " + hojaEtiq.id.ToString + " - " + hojaEtiq.nombre + "- Padre: " + seleccionado.Header.id.ToString)

            'Poner el tamaño minimo en la hoja de etiqueta
            Dim textBlock As New TextBlock()
            textBlock.Text = hojaEtiq.nombre
            textBlock.FontSize = textBlock.FontSize
            textBlock.Measure(New Size(Double.PositiveInfinity, Double.PositiveInfinity))
            Dim actualSize As New Size(textBlock.ActualWidth, textBlock.ActualHeight)
            hojaEtiq.Width = actualSize.Width

            Dim elemento As New TreeViewItem
            elemento.Header = hojaEtiq

            seleccionado.Items.Add(elemento)
            seleccionado.IsExpanded = True

            ponerMarcaAgua2()
        End If
    End Sub

    Private Sub OnSubmitCompletedIndependiente(ByVal so As SubmitOperation)
        If (so.HasError) Then
            MessageBox.Show(String.Format("Submit Failed: {0}", so.Error.Message))
            so.MarkErrorAsHandled()
        Else
            Dim seleccionado As TreeViewItem
            seleccionado = arbolEtiquetas.SelectedItem

            Dim query23 = (From EtiquetaId In Stado.cntxtIMaGe.ListadoEtiquetas Where EtiquetaId.Nombre = tb_nuevaEtiquetajerarquia.Text AndAlso EtiquetaId.Padre.Equals(Nothing) Select EtiquetaId.Id)

            Dim hojaEtiq As New HojaEtiqueta
            hojaEtiq.nombre = tb_nuevaEtiquetajerarquia.Text
            hojaEtiq.id = query23.First
            hojaEtiq.PonerNombre(hojaEtiq.nombre)

            Dim t As New Tag(hojaEtiq.nombre, hojaEtiq.id, 1)
            MyModel.model.T.Add(t)
            'MessageBox.Show("Se ha agregado la etiqueta con ID " + hojaEtiq.id.ToString + " - " + hojaEtiq.nombre)

            'Poner el tamaño minimo en la hoja de etiqueta
            Dim textBlock As New TextBlock()
            textBlock.Text = hojaEtiq.nombre
            textBlock.FontSize = textBlock.FontSize
            textBlock.Measure(New Size(Double.PositiveInfinity, Double.PositiveInfinity))
            Dim actualSize As New Size(textBlock.ActualWidth, textBlock.ActualHeight)
            hojaEtiq.Width = actualSize.Width

            Dim elemento As New TreeViewItem
            elemento.Header = hojaEtiq

            arbolEtiquetas.Items.Add(elemento)
            'seleccionado.IsExpanded = True

            ponerMarcaAgua2()
        End If
        'MessageBox.Show("Etiqueta(s) eliminada(s)")
    End Sub

    Private Sub ButtonEliminarEtiqueta_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles ButtonEliminarEtiqueta.Click

        Dim seleccion As String
        Dim hoja As New TreeViewItem
        hoja = arbolEtiquetas.SelectedItem
        seleccion = hoja.Header.nombre
        ' MessageBox.Show(seleccion)
        'MessageBox.Show(hoja.Items.Count)
        If seleccion IsNot Nothing Then ' ha seleccionado algo
            'Buscamos si esa etiqueta se está usando actualmente
            Dim query18 = (From EtiquetaUsando In Stado.cntxtIMaGe.EtiquetasImagens Where EtiquetaUsando.IdEtiqueta = hoja.Header.id Select EtiquetaUsando)

            If query18.Count = 0 Then 'No se está usando
                etiquetaUsada = True
                BuscarEtiquetasHijas(hoja)

                If Not etiquetaUsada Then 'Si alguna de las etiquetas hijas está siendo usada, no se puede borrar
                    'Metemos un error
                    MessageBox.Show("No se puede eliminar la etiqueta seleccionada, alguna de las subetiquetas está siendo usada.", "Error al eliminar la etiqueta.", MessageBoxButton.OK)

                Else

                    'Eliminamos la etiqueta de la base de datos
                    Dim query23 = (From EtiquetaEntera In Stado.cntxtIMaGe.ListadoEtiquetas Where EtiquetaEntera.Id = hoja.Header.id Select EtiquetaEntera)


                    'Eliminamos los hijos de la etiqueta
                    eliminarHijosEtiqueta(hoja.Header.id)

                    Stado.cntxtIMaGe.ListadoEtiquetas.Remove(query23.First)
                    Stado.cntxtIMaGe.SubmitChanges(AddressOf OnSubmitCompleted, Nothing)

                    'Eliminar de la lista del árbol
                    eliminarHojaDelArbol()

                End If
            Else
                'Metemos un error
                MessageBox.Show("La etiqueta que desea eliminar está siendo usada. Por tanto, no puede ser eliminada.", "Error al eliminar la etiqueta.", MessageBoxButton.OK)
            End If
        End If
    End Sub

    'Eliminar los hijos en la base de datos
    Private Sub eliminarHijosEtiqueta(ByVal idPadre As Integer)
        Dim query21 = (From etiquetaEntera In Stado.cntxtIMaGe.ListadoEtiquetas Where etiquetaEntera.Padre = idPadre Select etiquetaEntera)
        For index2 As Integer = 0 To query21.Count - 1
            eliminarHijosEtiqueta(query21.ElementAt(index2).Id)
            Stado.cntxtIMaGe.ListadoEtiquetas.Remove(query21.ElementAt(index2))
            'Stado.cntxtIMaGe.SubmitChanges(AddressOf OnSubmitCompleted, Nothing)
        Next
    End Sub


    'Cuando eliminamos una etiqueta, buscamos si las hijas de la  etiqueta están siendo utilizadas. No se puede eliminar: False
    Private Sub BuscarEtiquetasHijas(ByVal hoja As TreeViewItem)
        For index As Integer = 0 To hoja.Items.Count - 1
            'Buscamos el nombre de las hijas
            Dim seleccion As String
            seleccion = hoja.Items(index).Header.nombre

            Dim idEti As Integer
            idEti = hoja.Items(index).Header.id
            Dim query20 = (From EtiquetaUsando In Stado.cntxtIMaGe.EtiquetasImagens Where EtiquetaUsando.IdEtiqueta = idEti Select EtiquetaUsando)

            If query20.Count = 0 Then 'Si no esta siendo utilizada miramos a ver si tiene hijos, y volvemos a llamar a la función otra vez
                If hoja.Items(index).HasItems Then
                    BuscarEtiquetasHijas(hoja.Items(index))
                End If
            Else
                etiquetaUsada = False 'Está siendo utilizada
            End If
        Next
    End Sub

    Private Sub OnSubmitCompleted(ByVal so As SubmitOperation)
        If (so.HasError) Then
            MessageBox.Show(String.Format("Submit Failed: {0}", so.Error.Message))
            so.MarkErrorAsHandled()
        End If
        'MessageBox.Show("Etiqueta(s) eliminada(s)")
    End Sub


    Private Sub eliminarHojaDelArbol()
        Dim seleccionado As TreeViewItem
        seleccionado = arbolEtiquetas.SelectedItem

        'Si esta en el nivel más arriba del árbol
        If nivelSuperiorDelArbol(seleccionado) Then
            arbolEtiquetas.Items.Remove(seleccionado)
        Else 'solo eliminamos a las hijas
            Dim padre As TreeViewItem
            padre = seleccionado.Parent

            padre.Items.Remove(seleccionado)
        End If
    End Sub

    Private Function nivelSuperiorDelArbol(ByVal t As TreeViewItem) As Boolean
        If t.Parent.Equals(arbolEtiquetas) Then
            Return True
        Else
            Return False
        End If
    End Function

    Public Sub ActivarPanelNuevaEtiqueta()
        Me.TextBox_nuevaEtiqueta.IsEnabled = True
        Me.Button_añadir.IsEnabled = True
        Me.RadioButton_nuevo.IsEnabled = True
        Me.RadioButton_seleccionado.IsEnabled = True
    End Sub

    Public Sub DesactivarPanelNuevaEtiqueta()
        Me.TextBox_nuevaEtiqueta.IsEnabled = False
        Me.Button_añadir.IsEnabled = False
        Me.RadioButton_nuevo.IsEnabled = False
        Me.RadioButton_seleccionado.IsEnabled = False
    End Sub

    Private Sub tb_nuevaEtiquetajerarquia_GotFocus(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles tb_nuevaEtiquetajerarquia.GotFocus
        If marcaAgua2 Then
            ponerTextoNormal2()
        End If
    End Sub

End Class