﻿Imports System.Windows.Media.Imaging

Partial Public Class visor
    Inherits UserControl

    Private cropBox As Rect
    Private seleccion As Boolean 'Sirve para saber si se está realizando una selección en la pantalla o no
    Private MiMediador As Mediador
    Private imagenPrimera As New Image
    Private urlImag As String
    Private zoomMin As Double
    Private zoomLeft As Double 'Valores del zoom
    Private zoomTop As Double
    Private zoomWidth As Double
    Private zoomHeight As Double
    Private zoomAct As New Boolean 'Mirar si el zoom ha sido activado o no
    Private moverActivada As New Boolean
    Private originalPoint As New Point
    Private isPressed As Boolean = False
    Private moverX As Double
    Private moverY As Double
    Private Origen As Point
    Private Destino As Point


    Public Sub New()
        InitializeComponent()
        zoomAct = False
        moverActivada = False
        miCursor.Visibility = System.Windows.Visibility.Collapsed
        isPressed = False
        moverX = 0
        moverY = 0
        EtiquetarImagen()
    End Sub

    Public Sub conocerMediador(ByVal m As Mediador)
        MiMediador = m
    End Sub

    Private Sub UpdateCropBox()

        Canvas.SetLeft(cropUL, cropBox.Left)
        Canvas.SetTop(cropUL, cropBox.Top)

        Canvas.SetLeft(cropUR, cropBox.Left + cropBox.Width)
        Canvas.SetTop(cropUR, cropBox.Top)

        Canvas.SetLeft(cropBL, cropBox.Left)
        Canvas.SetTop(cropBL, cropBox.Top + cropBox.Height)

        Canvas.SetLeft(cropBR, cropBox.Left + cropBox.Width)
        Canvas.SetTop(cropBR, cropBox.Top + cropBox.Height)

        'Canvas.SetLeft(Panel_NuevaEtiqueta, cropBox.Left + cropBox.Width + 30)
        'Canvas.SetTop(Panel_NuevaEtiqueta, cropBox.Top + cropBox.Height + 30)

        UpdateMask()
    End Sub

    Private Sub UpdateMask()

        topMask.Height = cropBox.Top
        topMask.Width = cropBox.Left + cropBox.Width

        leftMask.Height = visorCanvas.Height - cropBox.Top
        leftMask.Width = cropBox.Left
        Canvas.SetTop(leftMask, cropBox.Top)

        rightMask.Height = cropBox.Height + cropBox.Top
        rightMask.Width = visorCanvas.Width - cropBox.Left - cropBox.Width
        Canvas.SetLeft(rightMask, cropBox.Left + cropBox.Width)

        bottomMask.Height = visorCanvas.Height - cropBox.Height - cropBox.Top
        bottomMask.Width = visorCanvas.Width - cropBox.Left
        Canvas.SetTop(bottomMask, cropBox.Height + cropBox.Top)
        Canvas.SetLeft(bottomMask, cropBox.Left)

    End Sub

    Public Sub limpiar_visor()
        If seleccion Then
            cropBox = New Rect(0, 0, visorCanvas.Width, visorCanvas.Height)
            cropBL.Visibility = Windows.Visibility.Collapsed
            cropBR.Visibility = Windows.Visibility.Collapsed
            cropUR.Visibility = Windows.Visibility.Collapsed
            cropUL.Visibility = Windows.Visibility.Collapsed
            UpdateMask()
            seleccion = False
        End If
    End Sub

    Private Sub EtiquetarEnElVisor(ByVal sender As System.Object, ByVal e As System.Windows.Input.MouseButtonEventArgs)
        If moverActivada Then
            originalPoint.X = e.GetPosition(visorCanvas).X
            originalPoint.Y = e.GetPosition(visorCanvas).Y
        Else
            seleccion = True

            If e.GetPosition(visorCanvas).X < 10 Or e.GetPosition(visorCanvas).Y < 10 Then
                cropBox = New Rect(e.GetPosition(Me.visorCanvas).X, e.GetPosition(Me.visorCanvas).Y, 20, 20)
            Else
                cropBox = New Rect(e.GetPosition(Me.visorCanvas).X - 10, e.GetPosition(Me.visorCanvas).Y - 10, 20, 20)
            End If

            cropUL.Visibility = Windows.Visibility.Visible
            cropBL.Visibility = Windows.Visibility.Visible
            cropUR.Visibility = Windows.Visibility.Visible
            cropBR.Visibility = Windows.Visibility.Visible

            Canvas.SetLeft(cropUL, e.GetPosition(Me.visorCanvas).X)
            Canvas.SetTop(cropUL, e.GetPosition(Me.visorCanvas).Y)

            Canvas.SetLeft(cropBL, e.GetPosition(Me.visorCanvas).X)
            Canvas.SetTop(cropBL, e.GetPosition(Me.visorCanvas).Y)

            Canvas.SetLeft(cropUR, e.GetPosition(Me.visorCanvas).X)
            Canvas.SetTop(cropUR, e.GetPosition(Me.visorCanvas).Y)

            Canvas.SetLeft(cropBR, e.GetPosition(Me.visorCanvas).X)
            Canvas.SetTop(cropBR, e.GetPosition(Me.visorCanvas).Y)

            UpdateCropBox()

            'Le decimos al mediador que le diga a la barra de herramientas que muestre el boton de limpiar Visor
            MiMediador.mostrarBotonLimpiar()
            'Le decimos al mediador que active el panel para agregar una nueva etiqueta
            MiMediador.activarPanelNuevaEtiqueta()
            'Le decimos al mediador que le diga a la barra de herramientas que muestre el botón de zoom
            If Me.ZoomActivado Then

            Else
                MiMediador.mostrarBotonZoom()
            End If

        End If
    End Sub

    Private Sub topMask_MouseLeftButtonDown(ByVal sender As System.Object, ByVal e As System.Windows.Input.MouseButtonEventArgs) Handles topMask.MouseLeftButtonDown

        seleccion = True

        If e.GetPosition(MiImagen).X < 10 Or e.GetPosition(MiImagen).Y < 10 Then
            cropBox = New Rect(e.GetPosition(Me.MiImagen).X, e.GetPosition(Me.MiImagen).Y, 20, 20)
        Else
            cropBox = New Rect(e.GetPosition(Me.MiImagen).X - 10, e.GetPosition(Me.MiImagen).Y - 10, 20, 20)
        End If

        cropUL.Visibility = Windows.Visibility.Visible
        cropBL.Visibility = Windows.Visibility.Visible
        cropUR.Visibility = Windows.Visibility.Visible
        cropBR.Visibility = Windows.Visibility.Visible

        Canvas.SetLeft(cropUL, e.GetPosition(Me.MiImagen).X)
        Canvas.SetTop(cropUL, e.GetPosition(Me.MiImagen).Y)

        Canvas.SetLeft(cropBL, e.GetPosition(Me.MiImagen).X)
        Canvas.SetTop(cropBL, e.GetPosition(Me.MiImagen).Y)

        Canvas.SetLeft(cropUR, e.GetPosition(Me.MiImagen).X)
        Canvas.SetTop(cropUR, e.GetPosition(Me.MiImagen).Y)

        Canvas.SetLeft(cropBR, e.GetPosition(Me.MiImagen).X)
        Canvas.SetTop(cropBR, e.GetPosition(Me.MiImagen).Y)


        UpdateCropBox()

    End Sub

    Private Sub bottomMask_MouseLeftButtonDown(ByVal sender As System.Object, ByVal e As System.Windows.Input.MouseButtonEventArgs) Handles bottomMask.MouseLeftButtonDown
        seleccion = True

        If e.GetPosition(visorCanvas).X < 10 Or e.GetPosition(visorCanvas).Y < 10 Then
            cropBox = New Rect(e.GetPosition(Me.visorCanvas).X, e.GetPosition(Me.MiImagen).Y, 20, 20)
        Else
            cropBox = New Rect(e.GetPosition(Me.visorCanvas).X - 10, e.GetPosition(Me.visorCanvas).Y - 10, 20, 20)
        End If

        cropUL.Visibility = Windows.Visibility.Visible
        cropBL.Visibility = Windows.Visibility.Visible
        cropUR.Visibility = Windows.Visibility.Visible
        cropBR.Visibility = Windows.Visibility.Visible

        Canvas.SetLeft(cropUL, e.GetPosition(Me.visorCanvas).X)
        Canvas.SetTop(cropUL, e.GetPosition(Me.visorCanvas).Y)

        Canvas.SetLeft(cropBL, e.GetPosition(Me.visorCanvas).X)
        Canvas.SetTop(cropBL, e.GetPosition(Me.visorCanvas).Y)

        Canvas.SetLeft(cropUR, e.GetPosition(Me.visorCanvas).X)
        Canvas.SetTop(cropUR, e.GetPosition(Me.visorCanvas).Y)

        Canvas.SetLeft(cropBR, e.GetPosition(Me.visorCanvas).X)
        Canvas.SetTop(cropBR, e.GetPosition(Me.visorCanvas).Y)


        UpdateCropBox()

    End Sub

    Private Sub leftMask_MouseLeftButtonDown(ByVal sender As System.Object, ByVal e As System.Windows.Input.MouseButtonEventArgs) Handles leftMask.MouseLeftButtonDown
        seleccion = True

        If e.GetPosition(visorCanvas).X < 10 Or e.GetPosition(visorCanvas).Y < 10 Then
            cropBox = New Rect(e.GetPosition(Me.visorCanvas).X, e.GetPosition(Me.visorCanvas).Y, 20, 20)
        Else
            cropBox = New Rect(e.GetPosition(Me.visorCanvas).X - 10, e.GetPosition(Me.visorCanvas).Y - 10, 20, 20)
        End If

        cropUL.Visibility = Windows.Visibility.Visible
        cropBL.Visibility = Windows.Visibility.Visible
        cropUR.Visibility = Windows.Visibility.Visible
        cropBR.Visibility = Windows.Visibility.Visible

        Canvas.SetLeft(cropUL, e.GetPosition(Me.visorCanvas).X)
        Canvas.SetTop(cropUL, e.GetPosition(Me.visorCanvas).Y)

        Canvas.SetLeft(cropBL, e.GetPosition(Me.visorCanvas).X)
        Canvas.SetTop(cropBL, e.GetPosition(Me.visorCanvas).Y)

        Canvas.SetLeft(cropUR, e.GetPosition(Me.visorCanvas).X)
        Canvas.SetTop(cropUR, e.GetPosition(Me.visorCanvas).Y)

        Canvas.SetLeft(cropBR, e.GetPosition(Me.visorCanvas).X)
        Canvas.SetTop(cropBR, e.GetPosition(Me.visorCanvas).Y)


        UpdateCropBox()

    End Sub

    Private Sub rightMask_MouseLeftButtonDown(ByVal sender As System.Object, ByVal e As System.Windows.Input.MouseButtonEventArgs) Handles rightMask.MouseLeftButtonDown
        seleccion = True

        cropBox = New Rect(e.GetPosition(Me.visorCanvas).X - 10, e.GetPosition(Me.visorCanvas).Y - 10, 20, 20)

        cropUL.Visibility = Windows.Visibility.Visible
        cropBL.Visibility = Windows.Visibility.Visible
        cropUR.Visibility = Windows.Visibility.Visible
        cropBR.Visibility = Windows.Visibility.Visible

        Canvas.SetLeft(cropUL, e.GetPosition(Me.visorCanvas).X)
        Canvas.SetTop(cropUL, e.GetPosition(Me.visorCanvas).Y)

        Canvas.SetLeft(cropBL, e.GetPosition(Me.visorCanvas).X)
        Canvas.SetTop(cropBL, e.GetPosition(Me.visorCanvas).Y)

        Canvas.SetLeft(cropUR, e.GetPosition(Me.visorCanvas).X)
        Canvas.SetTop(cropUR, e.GetPosition(Me.visorCanvas).Y)

        Canvas.SetLeft(cropBR, e.GetPosition(Me.visorCanvas).X)
        Canvas.SetTop(cropBR, e.GetPosition(Me.visorCanvas).Y)


        UpdateCropBox()

    End Sub

    Private Sub cropUL_DragDelta_1(ByVal sender As System.Object, ByVal e As System.Windows.Controls.Primitives.DragDeltaEventArgs) Handles cropUL.DragDelta
        Dim left As Double = Canvas.GetLeft(cropUL) + e.HorizontalChange
        Dim top As Double = Canvas.GetTop(cropUL) + e.VerticalChange

        If left > 0 AndAlso left < MiImagen.Width AndAlso cropBox.Width > e.HorizontalChange Then
            cropBox = New Rect(left, cropBox.Top, cropBox.Width - e.HorizontalChange, cropBox.Height)
        End If
        If top > 0 AndAlso top < MiImagen.Height AndAlso cropBox.Height > e.VerticalChange Then
            cropBox = New Rect(cropBox.Left, top, cropBox.Width, cropBox.Height - e.VerticalChange)
        End If
        UpdateCropBox()
    End Sub

    Private Sub cropUR_DragDelta_1(ByVal sender As System.Object, ByVal e As System.Windows.Controls.Primitives.DragDeltaEventArgs) Handles cropUR.DragDelta
        Dim left As Double = Canvas.GetLeft(cropUR) + e.HorizontalChange
        Dim top As Double = Canvas.GetTop(cropUR) + e.VerticalChange

        If left > 0 AndAlso left < MiImagen.Width AndAlso left > cropBox.Left Then
            cropBox = New Rect(cropBox.Left, cropBox.Top, left - cropBox.Left, cropBox.Height)
        End If
        If top > 0 AndAlso top < MiImagen.Height AndAlso cropBox.Height > e.VerticalChange Then
            cropBox = New Rect(cropBox.Left, top, cropBox.Width, cropBox.Height - e.VerticalChange)
        End If
        UpdateCropBox()
    End Sub

    Private Sub cropBL_DragDelta_1(ByVal sender As System.Object, ByVal e As System.Windows.Controls.Primitives.DragDeltaEventArgs) Handles cropBL.DragDelta
        Dim left As Double = Canvas.GetLeft(cropBL) + e.HorizontalChange
        Dim top As Double = Canvas.GetTop(cropBL) + e.VerticalChange
        If left > 0 AndAlso left < MiImagen.Width AndAlso cropBox.Width > e.HorizontalChange Then
            cropBox = New Rect(left, cropBox.Top, cropBox.Width - e.HorizontalChange, cropBox.Height)
        End If
        If top > 0 AndAlso top < MiImagen.Height AndAlso top > cropBox.Top Then
            cropBox = New Rect(cropBox.Left, cropBox.Top, cropBox.Width, top - cropBox.Top)
        End If
        UpdateCropBox()
    End Sub

    Private Sub cropBR_DragDelta_1(ByVal sender As System.Object, ByVal e As System.Windows.Controls.Primitives.DragDeltaEventArgs) Handles cropBR.DragDelta
        Dim left As Double = Canvas.GetLeft(cropBR) + e.HorizontalChange
        Dim top As Double = Canvas.GetTop(cropBR) + e.VerticalChange

        If left > 0 AndAlso left < MiImagen.Width AndAlso left > cropBox.Left Then
            cropBox = New Rect(cropBox.Left, cropBox.Top, left - cropBox.Left, cropBox.Height)
        End If
        If top > 0 AndAlso top < MiImagen.Height AndAlso cropBox.Height + e.VerticalChange > 0 Then
            cropBox = New Rect(cropBox.Left, cropBox.Top, cropBox.Width, cropBox.Height + e.VerticalChange)
        End If
        UpdateCropBox()
    End Sub

    Public Sub mostrarImagen(ByVal urlImagen As String)
        Dim uriImage As Uri
        uriImage = New Uri(urlImagen, UriKind.Relative)
        Dim objBI = New BitmapImage(uriImage)
        MiImagen.Source = objBI
        urlImag = urlImagen
    End Sub

    Public Function peticionRectangulo() As Rect
        Return cropBox
    End Function

    Public Function ZoomActivado() As Boolean
        Return zoomAct
    End Function

    'Devolvemos una lista con los paramentros más importantes del zoom, para poder escalar y guardar bien la imágenes
    Public Function DistanciasRectangulo() As List(Of Double)
        Dim lista As New List(Of Double)
        lista.Add(zoomLeft)
        lista.Add(zoomTop)
        lista.Add(zoomMin)
        lista.Add(zoomMin)
        lista.Add(zoomWidth)
        lista.Add(zoomHeight)
        Return lista
    End Function

    Public Sub zoom()
        'Guardamos los valores del rectangulo anterior
        Me.zoomLeft = cropBox.Left + moverX
        Me.zoomTop = cropBox.Top + moverY

        Dim imagenOriginal As New Image

        'Guardamos la imagen original por si el usuario quiere volver a ella
        imagenOriginal = MiImagen
        Me.imagenPrimera = MiImagen

        'Guardamos los valores del zoom para las etiquetas
        Dim zoomx As Double
        Dim zoomy As Double
        zoomx = visorCanvas.Width / cropBox.Width
        zoomy = visorCanvas.Height / cropBox.Height

        'Miramos la parte más pequeña para hacer el zoom
        Dim HeightRect As Double
        Dim WidthRect As Double
        If zoomx > zoomy Then 'Zoom está en la parte vertical (Top, Height), cambiar el Width
            zoomMin = zoomy
            HeightRect = cropBox.Height
            WidthRect = visorCanvas.Width / zoomMin

            zoomWidth = WidthRect
            zoomHeight = HeightRect

        Else 'Zoom está en la parte horizontal (Left, Width), cambiar el Height
            zoomMin = zoomx
            WidthRect = cropBox.Width
            HeightRect = visorCanvas.Height / zoomMin

            zoomWidth = WidthRect
            zoomHeight = HeightRect
        End If


        'Escalar la imagen
        Dim escalar As New ScaleTransform
        escalar.ScaleX = Me.zoomMin
        escalar.ScaleY = Me.zoomMin
        MiImagen.RenderTransform = escalar

        MiImagen.Source = imagenOriginal.Source

        'Transladar la parte de la imagen que queremos hacer zoom al punto (0,0)
        MiImagen.SetValue(Canvas.LeftProperty, -cropBox.Left * Me.zoomMin)
        MiImagen.SetValue(Canvas.TopProperty, -cropBox.Top * Me.zoomMin)

        'Activamos el zoom
        zoomAct = True

        'Llamamos al medidador para que ponga el boton de reset oculto y el de zoom otra vez oculto
        MiMediador.ocultarBotonZoom()
        MiMediador.mostrarBotonReset()
    End Sub

    Public Sub mostrarImagenOriginal()
        Me.MiImagen.RenderTransform = Nothing
        Me.MiImagen.Clip = Nothing
        Dim uriImage As Uri
        uriImage = New Uri(urlImag, UriKind.Relative)
        Dim objBI = New BitmapImage(uriImage)
        MiImagen.Source = objBI

        MiImagen.HorizontalAlignment = Windows.HorizontalAlignment.Center
        MiImagen.VerticalAlignment = Windows.VerticalAlignment.Center
        MiImagen.Height = 400
        MiImagen.Width = 600

        'Transladar la parte de la imagen que queremos hacer zoom al punto (0,0)
        MiImagen.SetValue(Canvas.LeftProperty, 0.0)
        MiImagen.SetValue(Canvas.TopProperty, 0.0)

        'Desactivamos el zoom
        Me.zoomAct = False

        'Quitamos el boton de la barra de herramientas
        Me.MiMediador.ocultarBotonLimpiar()
    End Sub

    'Para mover la imagen, ponemos el icono de la mano
    Public Sub iconoMano()
        visorCanvas.Cursor = Cursors.None
        AddHandler visorCanvas.MouseMove, AddressOf elegirMouse
        AddHandler visorCanvas.MouseLeftButtonDown, AddressOf leftButtonDownMouse
        AddHandler visorCanvas.MouseLeftButtonUp, AddressOf leftButtonUpMouse
        AddHandler visorCanvas.MouseLeave, AddressOf leaveMouse

    End Sub


    Private Sub elegirMouse(ByVal sender As System.Object, ByVal e As MouseEventArgs)
        'Ubicar el cursor
        miCursor.Visibility = System.Windows.Visibility.Visible
        Dim ptCursor As Point = e.GetPosition(visorCanvas)
        miCursor.SetValue(Canvas.LeftProperty, ptCursor.X)
        miCursor.SetValue(Canvas.TopProperty, ptCursor.Y)
        'Mover la imagen
        If (MiImagen.CaptureMouse) Then
            Dim pt As Point = e.GetPosition(visorCanvas)
            Dim movimiento As New Point
            movimiento.X = zoomLeft - (pt.X - Origen.X)
            movimiento.Y = zoomTop - (pt.Y - Origen.Y)
            MiImagen.SetValue(Canvas.LeftProperty, -movimiento.X * Me.zoomMin)
            MiImagen.SetValue(Canvas.TopProperty, -movimiento.Y * Me.zoomMin)
        End If

        If isPressed Then
            ShowCursor("cursor_drag_hand.png")
        Else
            ShowCursor("cursor_hand.png")
        End If
    End Sub


    Private Sub leftButtonDownMouse(ByVal sender As System.Object, ByVal e As MouseEventArgs)
        isPressed = True
        ShowCursor("cursor_drag_hand.png")
        MiImagen.CaptureMouse()
        Origen = e.GetPosition(visorCanvas)
        MiMediador.quitarCheck()

    End Sub

    Private Sub leftButtonUpMouse(ByVal sender As System.Object, ByVal e As MouseEventArgs)
        isPressed = False
        ShowCursor("cursor_hand.png")
        MiImagen.ReleaseMouseCapture()
        Destino = e.GetPosition(visorCanvas)
        zoomLeft = zoomLeft - (Destino.X - Origen.X)
        zoomTop = zoomTop - (Destino.Y - Origen.Y)
        Dim listaNueva As List(Of Double)
        listaNueva = DistanciasRectangulo()
        MiMediador.ponerHojaZoom(listaNueva)
        ' MiMediador.activarHojasZoom(listaNueva)
    End Sub

    Private Sub leaveMouse(ByVal sender As System.Object, ByVal e As MouseEventArgs)
        ShowCursor(String.Empty)
    End Sub

    Public Sub ShowCursor(ByVal imageName As String)
        Dim bi As New BitmapImage()
        Dim uri As New Uri("/IMaGeProject;component/ImagesProject/" + imageName, UriKind.Relative)
        bi.UriSource = uri
        miCursor.Source = bi
    End Sub

    Public Sub EtiquetarImagen()
        AddHandler MiImagen.MouseLeftButtonDown, AddressOf EtiquetarEnElVisor
    End Sub

    Public Sub EtiquetarImagenDesactivar()
        RemoveHandler MiImagen.MouseLeftButtonDown, AddressOf EtiquetarEnElVisor
    End Sub

    Public Sub PonerCursorOriginal()
        ShowCursor(String.Empty)
        miCursor.Visibility = System.Windows.Visibility.Collapsed
        visorCanvas.Cursor = Cursors.Arrow
    End Sub

    Public Sub EliminarMovimientosDeImagen()
        RemoveHandler visorCanvas.MouseMove, AddressOf elegirMouse
        RemoveHandler visorCanvas.MouseLeftButtonDown, AddressOf leftButtonDownMouse
        RemoveHandler visorCanvas.MouseLeftButtonUp, AddressOf leftButtonUpMouse
        RemoveHandler visorCanvas.MouseLeave, AddressOf leaveMouse
    End Sub


    'Cambiamos los cursores al pasar por los crops
    Private Sub cropUL_MouseEnter(ByVal sender As System.Object, ByVal e As System.Windows.Input.MouseEventArgs) Handles cropUL.MouseEnter
        visorCanvas.Cursor = Cursors.SizeNWSE
    End Sub

    Private Sub cropUL_MouseLeave(ByVal sender As System.Object, ByVal e As System.Windows.Input.MouseEventArgs) Handles cropUL.MouseLeave
        visorCanvas.Cursor = Cursors.Arrow
    End Sub

    Private Sub cropUR_MouseEnter(ByVal sender As System.Object, ByVal e As System.Windows.Input.MouseEventArgs) Handles cropUR.MouseEnter
        visorCanvas.Cursor = Cursors.SizeNESW
    End Sub

    Private Sub cropUR_MouseLeave(ByVal sender As System.Object, ByVal e As System.Windows.Input.MouseEventArgs) Handles cropUR.MouseLeave
        visorCanvas.Cursor = Cursors.Arrow
    End Sub

    Private Sub cropBL_MouseEnter(ByVal sender As System.Object, ByVal e As System.Windows.Input.MouseEventArgs) Handles cropBL.MouseEnter
        visorCanvas.Cursor = Cursors.SizeNESW
    End Sub

    Private Sub cropBL_MouseLeave(ByVal sender As System.Object, ByVal e As System.Windows.Input.MouseEventArgs) Handles cropBL.MouseLeave
        visorCanvas.Cursor = Cursors.Arrow
    End Sub

    Private Sub cropBR_MouseEnter(ByVal sender As System.Object, ByVal e As System.Windows.Input.MouseEventArgs) Handles cropBR.MouseEnter
        visorCanvas.Cursor = Cursors.SizeNWSE
    End Sub

    Private Sub cropBR_MouseLeave(ByVal sender As System.Object, ByVal e As System.Windows.Input.MouseEventArgs) Handles cropBR.MouseLeave
        visorCanvas.Cursor = Cursors.Arrow
    End Sub
End Class
