﻿Public Class Etiqueta
    Private padre As Integer
    Private id As Integer
    Private X As Integer
    Private Y As Integer
    Private Width As Integer
    Private Height As Integer
    Private observador As Canvas
    Private Rectangle As New Rectangle
    Private ColorRectangulo As SolidColorBrush
    Private ColorActivado As Boolean = False




    Public Sub New(ByRef padre_ As Integer, ByVal x_ As Integer, ByVal y_ As Integer, ByVal width_ As Integer, ByVal height_ As Integer, ByVal color_ As SolidColorBrush, ByVal id_ As Integer)
        padre = padre_
        X = x_
        Y = y_
        Width = width_
        Height = height_
        id = id_

        Rectangle.Height = Height
        Rectangle.Width = Width

        'Create a blue and a black Brush
        'Dim myBrush = New SolidColorBrush()
        'Dim rand As New Random
        'Dim op As Double
        'op = 256

        'myBrush.Color = Color.FromArgb(rand.Next(0, 256), rand.Next(0, 256), rand.Next(0, 256), rand.Next(0, 256))
        'myBrush.Color = Colors.Red

        'Set Rectangle's width and color
        Rectangle.StrokeThickness = 2
        'Rectangle.Stroke = myBrush
        ColorRectangulo = color_
        Rectangle.Stroke = ColorRectangulo
        ColorActivado = False

        'Pongo un relleno transparente
        Dim fillbrush As New SolidColorBrush()
        Dim relleno As Color

        relleno = Color.FromArgb(0, 0, 0, 0)
        fillbrush.Color = relleno
        Rectangle.Fill = fillbrush

        'Fill rectangle with blue color
        'blueRectangle.Fill = blueBrush
        Rectangle.Margin = New Thickness(2, 2, 2, 2)

        'Add Rectangle to the Grid.
        Canvas.SetLeft(Rectangle, X)
        Canvas.SetTop(Rectangle, Y)

        AddHandler Rectangle.MouseEnter, AddressOf Rectangle_MouseEnter
        AddHandler Rectangle.MouseLeave, AddressOf Rectangle_MouseLeave

    End Sub

    Public Function get_padre() As Integer
        Return padre
    End Function

    Public Function get_X() As Integer
        Return X
    End Function

    Public Function get_Y() As Integer
        Return Y
    End Function

    Public Function get_Width() As Integer
        Return Width
    End Function

    Public Function get_Height() As Integer
        Return Height
    End Function

    Public Function get_ColorRectangulo() As SolidColorBrush
        Return ColorRectangulo
    End Function

    Public Function get_id() As Integer
        Return Me.id
    End Function

    Public Function get_Rectangulo() As Rectangle
        Return Rectangle
    End Function

    Public Function get_observador() As Canvas
        Return observador
    End Function

    Public Function get_colorActivado() As Boolean
        Return ColorActivado
    End Function

    Public Sub set_observador(ByVal o As Canvas)
        observador = o
    End Sub

    Public Overridable Sub pintar_etiqueta()
        observador.Children.Add(Rectangle)
        If ColorActivado Then
            Rectangle.Stroke = ColorRectangulo
        End If
    End Sub

    Public Sub borrar_etiqueta()
        borrar_relleno()
        observador.Children.Remove(Rectangle)
    End Sub

    Public Sub rellenar_etiqueta()
        Dim fillbrush As New SolidColorBrush()
        Dim relleno As Color

        relleno = Color.FromArgb(100, 125, 225, 125)
        fillbrush.Color = relleno
        Rectangle.Fill = fillbrush
    End Sub

    Public Sub borrar_relleno()
        Dim fillbrush As New SolidColorBrush()
        Dim relleno As Color

        relleno = Color.FromArgb(0, 0, 0, 0)
        fillbrush.Color = relleno
        Rectangle.Fill = fillbrush
    End Sub

    Private Sub Rectangle_MouseEnter(ByVal sender As System.Object, ByVal e As System.Windows.Input.MouseEventArgs)
        rellenar_etiqueta()
    End Sub

    Private Sub Rectangle_MouseLeave(ByVal sender As System.Object, ByVal e As System.Windows.Input.MouseEventArgs)
        borrar_relleno()
    End Sub

    'Cambiar color al rectangulo
    Public Sub CambiarColor(ByVal ColorParaRectangulo As SolidColorBrush)
        ColorActivado = True
        ColorRectangulo = ColorParaRectangulo
    End Sub
End Class
