﻿Imports System.Windows.Media.Imaging

Partial Public Class MainACoAR
    Inherits Page

    Public Sub New()
        InitializeComponent()
    End Sub

    'Se ejecuta cuando el usuario navega a esta página.
    Protected Overrides Sub OnNavigatedTo(ByVal e As System.Windows.Navigation.NavigationEventArgs)

    End Sub

    Private Sub conceptNameEnter(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        Dim tb As TextBlock = CType(sender, TextBlock)
        tb.Foreground = New SolidColorBrush(Colors.Blue)
    End Sub

    Private Sub conceptNameLeave(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        Dim tb As TextBlock = CType(sender, TextBlock)
        tb.Foreground = New SolidColorBrush(Colors.Black)
    End Sub

    Private Sub conceptNameClick(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        Dim tb As TextBlock = CType(sender, TextBlock)
        tb.Foreground = New SolidColorBrush(Colors.Red)

        mostrarRecursos(MyModel.model.Z.getClassificationConcept(tb.Text))

    End Sub
    Private Sub conceptNameClickLeave(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        Dim tb As TextBlock = CType(sender, TextBlock)
        tb.Foreground = New SolidColorBrush(Colors.Blue)
    End Sub

    Private Sub mostrarRecursos(ByVal cc As ClasificationConcept)
        RSP.Children.Clear()
        For Each r As Resource In cc.classifiedResources
            Dim tb As New TextBlock
            'tb.Text = "    R" + r.id + "    "
            Dim idR As Integer = r.id
            Dim qRecurso = (From x In Stado.cntxtIMaGe.Imagenes Where x.id = idR Select x)

            tb.Text = "    " + qRecurso.First.Nombre
            tb.FontSize = 14
            AddHandler tb.MouseEnter, AddressOf resourceEnter
            AddHandler tb.MouseLeave, AddressOf resourceLeave
            AddHandler tb.MouseLeftButtonDown, AddressOf resourceClick
            AddHandler tb.MouseLeftButtonUp, AddressOf resourceClickLeave

            RSP.Children.Add(tb)
        Next
    End Sub

    Private Sub resourceEnter(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        Dim tb As TextBlock = CType(sender, TextBlock)
        tb.Foreground = New SolidColorBrush(Colors.Blue)
    End Sub

    Private Sub resourceLeave(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        Dim tb As TextBlock = CType(sender, TextBlock)
        tb.Foreground = New SolidColorBrush(Colors.Black)
    End Sub

    Private Sub resourceClick(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        Dim tb As TextBlock = CType(sender, TextBlock)
        tb.Foreground = New SolidColorBrush(Colors.Red)

        Dim idresource As String = tb.Text.Substring(4)

        'Cogemos el recurso y mostramos su imagen correspondiente
        Dim qRecurso = (From x In Stado.cntxtIMaGe.Imagenes Where x.Nombre = idresource Select x)

        Dim uriImage As Uri
        uriImage = New Uri(qRecurso.First.Ruta, UriKind.Relative)
        Dim objBI = New BitmapImage(uriImage)
        myImage.Source = objBI

        'Mostramos el nombre de la imagen
        tb_tagHeader.Text = qRecurso.First.Nombre + ":"
        tb_tagHeader.FontSize = 18
        tb_tagHeader.Foreground = New SolidColorBrush(Colors.Blue)

        'Mostramos las etiquetas de la imagen
        Dim qqEtiquetasDelRecurso = (From x In Stado.cntxtIMaGe.EtiquetasImagens Where x.IdImagen = qRecurso.First.id Select x)

        'MessageBox.Show("numero de filas: " + qqEtiquetasDelRecurso.Count.ToString)
        SP_tags.Children.Clear()
        For i As Integer = 0 To qqEtiquetasDelRecurso.Count - 1
            Dim newtb As New TextBlock
            Dim qqNombreEtiqueta = (From x In Stado.cntxtIMaGe.ListadoEtiquetas Where x.Id = qqEtiquetasDelRecurso.ElementAt(i).IdEtiqueta Select x.Nombre)
            newtb.Text = " > " + qqNombreEtiqueta.First + " (" + qqEtiquetasDelRecurso.ElementAt(i).Votos.ToString + " veces)"
            SP_tags.Children.Add(newtb)
        Next



    End Sub

    Private Sub resourceClickLeave(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        Dim tb As TextBlock = CType(sender, TextBlock)
        tb.Foreground = New SolidColorBrush(Colors.Blue)
    End Sub

    Private Sub Page_Loaded(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded
        For Each cc As ClasificationConcept In MyModel.model.Z.getConcepts
            Dim tb As New TextBlock
            tb.FontSize = 14
            tb.Text = cc.getConceptName
            AddHandler tb.MouseEnter, AddressOf conceptNameEnter
            AddHandler tb.MouseLeave, AddressOf conceptNameLeave
            AddHandler tb.MouseLeftButtonDown, AddressOf conceptNameClick
            AddHandler tb.MouseLeftButtonUp, AddressOf conceptNameClickLeave

            CCSP.Children.Add(tb)
        Next
    End Sub
End Class
