﻿Imports IMaGeProject.Web
Imports System.ServiceModel.DomainServices.Client

Partial Public Class MainPage
    Inherits UserControl

    Private MiMediador As Mediador
    Private MiListaImagenes As List(Of ImagenEtiquetada)
    Private MiListaParaZoom As New List(Of VisualizarConZoom)
    Private MiImagen As ImagenEtiquetada
    Private index As Integer = 0

    Public Sub New()
        InitializeComponent()
        MiMediador = New Mediador(MiVisor, MiBarraHerramientas, MiPanelNuevaEtiqueta, MiArbol, MiGaleria)
        MiVisor.conocerMediador(MiMediador)
        MiBarraHerramientas.conocerMediador(MiMediador)
        MiPanelNuevaEtiqueta.conocerMediador(MiMediador)
        MiArbol.conocerMediador(MiMediador)
        MiGaleria.conocerMediador(MiMediador)
        MiMediador.conocerAplicacion(Me)
        MiMediador.desactivarPanelNuevaEtiqueta()
        MiListaImagenes = New List(Of ImagenEtiquetada)

        'Base de datos
        If (Stado.cntxtIMaGe Is Nothing) Then
            Stado.cntxtIMaGe = New IMaGeDomainContext

            'EtiquetasImagen
            Stado.cntxtIMaGe.Load(Of EtiquetasImagen)(Stado.cntxtIMaGe.GetEtiquetasImagenQuery())

            'Imagenes
            Stado.cntxtIMaGe.Load(Of Imagenes)(Stado.cntxtIMaGe.GetImagenesQuery())

            'ListadoEtiquetas
            Stado.cntxtIMaGe.Load(Of ListadoEtiquetas)(Stado.cntxtIMaGe.GetListadoEtiquetasQuery())

        End If


    End Sub

    Public Function buscarImagen(ByVal IdImagen As Integer) As ImagenEtiquetada
        Dim index As Integer
        index = 0
        If MiListaImagenes.Count = 0 Then
            Return Nothing
        Else

            While index < MiListaImagenes.Count - 1 And MiListaImagenes(index).get_IdImagen <> IdImagen
                index = index + 1
            End While

            If index < MiListaImagenes.Count - 1 Then
                Return MiListaImagenes(index)
            ElseIf index = MiListaImagenes.Count - 1 And MiListaImagenes(index).get_IdImagen = IdImagen Then
                Return MiListaImagenes(index)
            Else
                Return Nothing
            End If
        End If



    End Function

    'Cargar la lista con las etiquetas de la base de datos
    Public Function CargarEtiquetasEnLista(ByVal c As Canvas, ByVal Imagen As ImagenEtiquetada) As ImagenEtiquetada
        Imagen.eliminar_TodasLasEtiquetas()
        Dim query10 = (From EtiquetaEntera In Stado.cntxtIMaGe.EtiquetasImagens Where EtiquetaEntera.IdImagen = Imagen.get_IdImagen Select EtiquetaEntera)
        For index As Integer = 0 To query10.Count - 1
            Dim colorActual As SolidColorBrush
            colorActual = New SolidColorBrush(Color.FromArgb(Convert.ToByte(query10.ElementAt(index).Color.Substring(1, 2), 16), Convert.ToByte(query10.ElementAt(index).Color.Substring(3, 2), 16), Convert.ToByte(query10.ElementAt(index).Color.Substring(5, 2), 16), Convert.ToByte(query10.ElementAt(index).Color.Substring(7, 2), 16)))
            Imagen.añadir_etiqueta(query10.ElementAt(index).Padre, query10.ElementAt(index).X, query10.ElementAt(index).Y, query10.First.Width, query10.ElementAt(index).Height, c, colorActual, query10.ElementAt(index).Id)
        Next
        Return Imagen
    End Function

    Public Sub instanciarImagen(ByVal idImagen As Integer, ByVal c As Canvas)
        'Aquí se debe coger los datos de la imagen de una base de datos: ruta, nombre, etiquetas...
        'Buscamos una instancia anteriores de esta imagen

        Dim imagenAux As ImagenEtiquetada
        imagenAux = buscarImagen(idImagen)

        If IsNothing(imagenAux) Then 'Cuando en la imagen actual no hay etiquetas
            Dim nuevaImagen As New ImagenEtiquetada(idImagen)
            nuevaImagen.set_observador(MiArbol)
            nuevaImagen.arbolObservador.limpiarArbol()
            nuevaImagen = CargarEtiquetasEnLista(c, nuevaImagen)
            MiImagen = nuevaImagen
            MiListaImagenes.Add(nuevaImagen)
        Else 'En la imagen actual hay etiquetas
            MiImagen = imagenAux
            MiImagen.arbolObservador.limpiarArbol()
            'MiImagen.arbolObservador.cargarArbol(idImagen)
        End If
    End Sub

    Public Sub añadirEtiqueta(ByVal padre As String, ByVal Left As Double, ByVal Top As Double, ByVal Width As Double, ByVal Height As Double, ByVal colorRec As SolidColorBrush, ByVal id As Integer)
        MiImagen.añadir_etiqueta(padre, Left, Top, Width, Height, MiVisor.visorCanvas, colorRec, id)
    End Sub


    Public Sub visualizarEtiqueta(ByVal idEtiqueta As Integer)
        Dim eti As Etiqueta
        eti = MiImagen.buscar_etiqueta(idEtiqueta)
        eti.pintar_etiqueta()
    End Sub

    Public Sub visualizarEtiquetaZoom(ByVal idEtiqueta As Integer, ByVal lista As List(Of Double), ByVal c As Canvas)
        Dim eti As Etiqueta
        eti = MiImagen.buscar_etiqueta(idEtiqueta)
        Dim visualizador As New VisualizarConZoom(eti.get_padre, eti.get_X, eti.get_Y, eti.get_Width, eti.get_Height, eti.get_ColorRectangulo, lista, idEtiqueta)
        visualizador.set_observador(c)
        MiListaParaZoom.Add(visualizador)
        visualizador.pintar_etiqueta()
        visualizador.rellenar_etiqueta()
    End Sub

    Public Sub visualizarEtiquetaConRelleno(ByVal idEtiqueta As Integer)
        Dim eti As Etiqueta
        eti = MiImagen.buscar_etiqueta(idEtiqueta)
        eti.pintar_etiqueta()
        eti.rellenar_etiqueta()
    End Sub

    Public Sub visualizarEtiquetaConRellenoZoom(ByVal idEtiqueta As Integer, ByVal lista As List(Of Double), ByVal c As Canvas)
        Dim eti As Etiqueta
        eti = MiImagen.buscar_etiqueta(idEtiqueta)
        Dim visualizador As New VisualizarConZoom(eti.get_padre, eti.get_X, eti.get_Y, eti.get_Width, eti.get_Height, eti.get_ColorRectangulo, lista, idEtiqueta)
        visualizador.set_observador(c)
        MiListaParaZoom.Add(visualizador)
        visualizador.pintar_etiqueta()
        visualizador.rellenar_etiqueta()
    End Sub

    Public Sub noVisualizarEtiquetaConRelleno(ByVal idEtiqueta As Integer)
        Dim eti As Etiqueta
        eti = MiImagen.buscar_etiqueta(idEtiqueta)
        eti.borrar_relleno()
    End Sub

    Public Sub noVisualizarEtiquetaConRellenoZoom(ByVal idEtiqueta As Integer)
        Dim eti As Etiqueta

        eti = MiImagen.buscar_etiqueta(idEtiqueta)
        Dim visualizador As VisualizarConZoom
        visualizador = MiImagen.buscar_etiqueta_zoom(eti.get_id(), MiListaParaZoom)
        visualizador.borrar_etiqueta()
        MiListaParaZoom.Remove(visualizador)
    End Sub

    Public Sub noVisualizarEtiqueta(ByVal idEtiqueta As Integer)
        Dim eti As Etiqueta
        eti = MiImagen.buscar_etiqueta(idEtiqueta)
        eti.borrar_etiqueta()
    End Sub


    Public Sub noVisualizarEtiquetaZoom(ByVal idEtiqueta As Integer)
        Dim eti As Etiqueta
        eti = MiImagen.buscar_etiqueta(idEtiqueta)
        Dim visualizador As VisualizarConZoom
        visualizador = MiImagen.buscar_etiqueta_zoom(eti.get_id(), MiListaParaZoom)
        visualizador.borrar_etiqueta()
        MiListaParaZoom.Remove(visualizador)
    End Sub

    Public Sub eliminarEtiqueta(ByVal idEtiqueta As Integer, ByVal zoomActivado As Boolean)
        Dim eti As Etiqueta
        eti = MiImagen.buscar_etiqueta(idEtiqueta)
        If zoomActivado Then 'Miramos si el zoom está activado, para eliminarlo de la lista
            Dim visualizador As VisualizarConZoom
            visualizador = MiImagen.buscar_etiqueta_zoom(eti.get_id(), MiListaParaZoom)
            MiImagen.eliminar_etiqueta_zoom(visualizador, MiListaParaZoom)
            visualizador.borrar_etiqueta()
        End If
        MiImagen.eliminar_etiqueta(eti)
    End Sub

    Public Sub CambiarColorEtiqueta(ByVal idEtiqueta As Integer, ByVal ColorParaRectangulo As SolidColorBrush)
        Dim eti As Etiqueta
        eti = MiImagen.buscar_etiqueta(idEtiqueta)
        eti.CambiarColor(ColorParaRectangulo)
    End Sub

    Public Function buscaEtiqueta(ByVal idEtiqueta As Integer) As Etiqueta
        Dim eti As Etiqueta
        eti = MiImagen.buscar_etiqueta(idEtiqueta)
        Return eti
    End Function

    Public Function get_ListaImagenes() As List(Of Etiqueta)
        Return MiImagen.get_etiquetas
    End Function

    Private Sub EtiquetasImagenDomainDataSource_LoadedData(ByVal sender As System.Object, ByVal e As System.Windows.Controls.LoadedDataEventArgs) Handles EtiquetasImagenDomainDataSource.LoadedData

        If e.HasError Then
            System.Windows.MessageBox.Show(e.Error.ToString, "Load Error", System.Windows.MessageBoxButton.OK)
            e.MarkErrorAsHandled()
        Else
            If MyModel.model Is Nothing Then

                'Creamos el modelo ACoAR
                Dim myfolksonomy As Folksonomy = DataAccess.getDataFromDB()

                'Cogemos la folksonomia y creamos un modelo ACoAR
                Dim model As New ModelACoAR(myfolksonomy)
                MyModel.model = model


                'Vamos a hacer un ACoAR_Creation
                Dim myACoAR As New ACoAR
                MyModel.ACoAR = myACoAR
                Dim myDictionary As New DictionaryNAnnotations
                myDictionary.setMina(20)
                Dim myConvergence As New ConvergencenAnnotations
                myConvergence.setMinNAnnotations(60)
                Dim myClustering As New ClusteringDistribKMeans
                myClustering.setK(5)
                Dim similarity As New SimilarityMeasureCosine
                myClustering.setSimilarityMeasure(similarity)
                Dim mergsplit As New MergingSimilar
                mergsplit.setThreshold(0.8)
                mergsplit.setSimilarityMeasure(similarity)
                Dim myClassifier As New ClassifierDelta
                myClassifier.setSimilarityMeasure(similarity)
                myClassifier.setThreshold(0.1)
                Dim myNaming As New NamingSimple
                Dim mySimilarities As New Similarities
                mySimilarities.setSimilarityMeasure(similarity)
                Dim myRecalculation As New maximunChangesLimitRecalculation

                myACoAR.setModel(model)
                myACoAR.setDictionaryStrategy(myDictionary)
                myACoAR.setConvergenceCriterion(myConvergence)
                myACoAR.setClusteringStrategy(myClustering)
                myACoAR.setMergingSplittingStrategy(mergsplit)
                myACoAR.setClassifier(myClassifier)
                myACoAR.setNamingStrategy(myNaming)
                myACoAR.setSimilaritiesStrategy(mySimilarities)
                myACoAR.setRecalculationConditionCriterion(myRecalculation)

                myACoAR.ModelACoAR_Creation()

                ACoARFrame.Navigate(New Uri("/MainACoAR.xaml", UriKind.Relative))

            End If
            

        End If


    End Sub

    Private Sub UserControl_Loaded(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded

    End Sub
End Class