﻿Imports IMaGeProject.Web
Imports System.ServiceModel.DomainServices.Client

Public Class Mediador
    Private MiVisor As visor
    Private MiBarra As barraDeHerramientas
    Private MiPanel As panelNuevaEtiqueta
    Private MiArbol As arbol
    Private MiGaleria As galeria
    Private MiAplicacion As MainPage


    Public Sub New(ByVal v As visor, ByVal b As barraDeHerramientas, ByVal p As panelNuevaEtiqueta, ByVal a As arbol, ByVal g As galeria)
        MiVisor = v
        MiBarra = b
        MiPanel = p
        MiArbol = a
        MiGaleria = g
    End Sub

    Public Sub conocerAplicacion(ByVal ap As MainPage)
        MiAplicacion = ap
    End Sub


    Public Sub limpiarVisor()
        MiVisor.limpiar_visor()
    End Sub

    Public Sub nuevaImagen(ByVal urlImagen As String)

        Dim idImagen As Integer
        idImagen = MiGaleria.getIdImagen()
        MiAplicacion.instanciarImagen(idImagen, MiVisor.visorCanvas)
        MiVisor.mostrarImagen(urlImagen)

    End Sub

    Public Sub nuevaEtiqueta(ByVal nombreEtiqueta As String, ByVal hija As Boolean, ByVal colorRec As SolidColorBrush)

        Dim rectangulo As Rect
        rectangulo = MiVisor.peticionRectangulo

        Dim padre As String

        'Miramos si el zoom ha sido activado
        If MiVisor.ZoomActivado Then
            'Poner bien las posiciones del rectangulo, ya que en el zoom son irreales
            Dim lista As New List(Of Double)
            lista = MiVisor.DistanciasRectangulo

            If hija Then
                padre = MiArbol.indicarPadre()
                meterDatos(nombreEtiqueta, padre, (rectangulo.Left / lista.Item(2)) + lista.Item(0), lista.Item(1) + (rectangulo.Top / lista.Item(3)), (rectangulo.Width / lista.Item(2)), (rectangulo.Height / lista.Item(3)), colorRec.Color.ToString)
            Else
                meterDatos(nombreEtiqueta, Nothing, (rectangulo.Left / lista.Item(2)) + lista.Item(0), lista.Item(1) + (rectangulo.Top / lista.Item(3)), (rectangulo.Width / lista.Item(2)), (rectangulo.Height / lista.Item(3)), colorRec.Color.ToString)
            End If
        Else


            If hija Then
                padre = MiArbol.indicarPadre()
                meterDatos(nombreEtiqueta, padre, rectangulo.Left, rectangulo.Top, rectangulo.Width, rectangulo.Height, colorRec.Color.ToString)
            Else
                meterDatos(nombreEtiqueta, Nothing, rectangulo.Left, rectangulo.Top, rectangulo.Width, rectangulo.Height, colorRec.Color.ToString)
            End If

        End If

    End Sub

    Private Sub meterDatos(ByVal nombreEtiqueta As String, ByVal padre As Integer, ByVal x As Integer, ByVal y As Integer, ByVal width As Integer, ByVal height As Integer, ByVal color As String)
        'Creamos el objeto para meter los datos a la base de datos
        Dim etiquetaBD As New EtiquetasImagen
        Dim query3 = (From etiquetaId In Stado.cntxtIMaGe.ListadoEtiquetas Where etiquetaId.Nombre = nombreEtiqueta Select etiquetaId.Id)
        etiquetaBD.IdEtiqueta = query3.First
        etiquetaBD.IdImagen = ObtenerIdImagen()
        etiquetaBD.Padre = padre
        etiquetaBD.X = x
        etiquetaBD.Y = y
        etiquetaBD.Width = width
        etiquetaBD.Height = height
        etiquetaBD.Color = color
        etiquetaBD.Votos = 1

        'Insertamos el objeto en la base de datos, y nos aseguramos de que la inserción haya sido correcta (trabaja de un modo asíncrono)
        Stado.cntxtIMaGe.EtiquetasImagens.Add(etiquetaBD)
        Stado.cntxtIMaGe.SubmitChanges(AddressOf OnSubmitCompletedAñadir, Nothing)

        'Metemos la anotación en el modelo.
        'Anotación con la etiqueta, el recurso y una unica anotación
        Dim t As Tag = MyModel.model.getTag(etiquetaBD.Id)
        Dim r As Resource = MyModel.model.getAResource(etiquetaBD.IdImagen)
        Dim a As New Annotation(t, r, 1)
        MyModel.model.A.Add(a)

        'MessageBox.Show("Se ha creado una nueva anotación: " + vbCrLf + _
        '                "Imagen: " + etiquetaBD.IdImagen.ToString + vbCrLf + _
        '                "Etiqueta: " + etiquetaBD.IdEtiqueta.ToString + vbCrLf + _
        '                "Votos: " + etiquetaBD.Votos.ToString)

        'Creamos una nueva estancia Tagging
        Dim tg As New Tagging(r, t, "create")
        MyModel.ACoAR.ModelACoAR_Evolution(tg)

        ' MessageBox.Show(etiquetaBD.X + ", " + etiquetaBD.Y + ", " + etiquetaBD.Width + ", " + etiquetaBD.Height + ", " + etiquetaBD.Color + ", " + etiquetaBD.IdEtiqueta + ", " + etiquetaBD.IdImagen)
        
    End Sub

    Private Sub OnSubmitCompletedAñadir(ByVal so As SubmitOperation)
        If (so.HasError) Then
            MessageBox.Show(String.Format("Submit Failed: {0}", so.Error.Message))
            so.MarkErrorAsHandled()
        Else
            'Una vez añadida la etiqueta a la base de datos, la insertamos en la interfaz
            añadeEtiqueta()

            'MessageBox.Show("Etiqueta añadida.")
        End If

    End Sub

    'Insertar etiqueta en el árbol de etiquetado
    Private Sub añadeEtiqueta()

        'Cogemos todas las etiquetas, pero luego solo nos quedamos con la última (query.Last)
        Dim query = (From listadoDeTodo In Stado.cntxtIMaGe.EtiquetasImagens Select listadoDeTodo)
        Dim query2 = (From etiquetaNombre In Stado.cntxtIMaGe.ListadoEtiquetas Where etiquetaNombre.Id = query.Last.IdEtiqueta Select etiquetaNombre.Nombre)

        Dim colorActual As SolidColorBrush
        colorActual = New SolidColorBrush(Color.FromArgb(Convert.ToByte(query.Last.Color.Substring(1, 2), 16), Convert.ToByte(query.Last.Color.Substring(3, 2), 16), Convert.ToByte(query.Last.Color.Substring(5, 2), 16), Convert.ToByte(query.Last.Color.Substring(7, 2), 16)))
        MiAplicacion.añadirEtiqueta(query.Last.Padre, query.Last.X, query.Last.Y, query.Last.Width, query.Last.Height, colorActual, query.Last.Id)

        If query.Last.Padre = 0 Or query.Last.Padre Is Nothing Then 'Si la etiqueta es padre
            MiArbol.añadirHojaIndependiente(query2.First, query.Last.Id, colorActual)

        Else 'Si la etiqueta es hija
            MiArbol.añadirHojaHija(query2.First, query.Last.Id)

        End If
    End Sub


    Public Sub activarPanelNuevaEtiqueta()
        MiPanel.ActivarPanelNuevaEtiqueta()
    End Sub

    Public Sub desactivarPanelNuevaEtiqueta()
        MiPanel.DesactivarPanelNuevaEtiqueta()
    End Sub

    Public Sub eliminarHoja(ByVal idEtiqueta As Integer)

        'Buscamos la etiqueta en la BDD
        Dim query = (From etiquetaEntera In Stado.cntxtIMaGe.EtiquetasImagens Where etiquetaEntera.Id = idEtiqueta Select etiquetaEntera)
        'Eliminamos los hijos de la etiqueta
        eliminarHijosEtiquetaEnBD(query.First.Id)

        'Eliminamos la etiqueta seleccionada
        Stado.cntxtIMaGe.EtiquetasImagens.Remove(query.First)

        Stado.cntxtIMaGe.SubmitChanges(AddressOf OnSubmitCompleted, Nothing)

        'Eliminamos del árbol de etiquetado
        Dim estaZoomActivado As Boolean
        estaZoomActivado = MiVisor.ZoomActivado()
        etiquetaUncheck(idEtiqueta)
        MiAplicacion.eliminarEtiqueta(idEtiqueta, estaZoomActivado)
        MiArbol.eliminarHoja()

    End Sub

    'Eliminar los hijos en la base de datos
    Private Sub eliminarHijosEtiquetaEnBD(ByVal idPadre As Integer)
        Dim query22 = (From etiquetaEntera In Stado.cntxtIMaGe.EtiquetasImagens Where etiquetaEntera.Padre = idPadre Select etiquetaEntera)
        For index2 As Integer = 0 To query22.Count - 1
            eliminarHijosEtiquetaEnBD(query22.ElementAt(index2).Id)
            Stado.cntxtIMaGe.EtiquetasImagens.Remove(query22.ElementAt(index2))
            'Stado.cntxtIMaGe.SubmitChanges(AddressOf OnSubmitCompleted, Nothing)
        Next
    End Sub

    Private Sub OnSubmitCompleted(ByVal so As SubmitOperation)
        If (so.HasError) Then
            MessageBox.Show(String.Format("Submit Failed: {0}", so.Error.Message))
            so.MarkErrorAsHandled()
        End If
        'MessageBox.Show("Etiqueta(s) eliminada(s)")
    End Sub

    Public Sub etiquetaCheck(ByVal idEtiqueta As Integer)
        Dim estaZoomActivado As Boolean
        estaZoomActivado = MiVisor.ZoomActivado()
        If estaZoomActivado Then
            Dim lista As New List(Of Double)
            lista = MiVisor.DistanciasRectangulo
            MiAplicacion.visualizarEtiquetaZoom(idEtiqueta, lista, MiVisor.visorCanvas)
        Else
            MiAplicacion.visualizarEtiqueta(idEtiqueta)
        End If
    End Sub

    Public Sub etiquetaHojaMouseEnter(ByVal idEtiqueta As Integer)
        Dim estaZoomActivado As Boolean
        estaZoomActivado = MiVisor.ZoomActivado()
        If estaZoomActivado Then
            Dim lista As New List(Of Double)
            lista = MiVisor.DistanciasRectangulo
            MiAplicacion.visualizarEtiquetaConRellenoZoom(idEtiqueta, lista, MiVisor.visorCanvas)
        Else
            MiAplicacion.visualizarEtiquetaConRelleno(idEtiqueta)
        End If
    End Sub


    Public Sub etiquetaHojaMouseLeave(ByVal idEtiqueta As Integer)
        Dim estaZoomActivado As Boolean
        estaZoomActivado = MiVisor.ZoomActivado()
        If estaZoomActivado Then
            MiAplicacion.noVisualizarEtiquetaConRellenoZoom(idEtiqueta)
        Else
            MiAplicacion.noVisualizarEtiquetaConRelleno(idEtiqueta)
        End If

    End Sub

    Public Sub etiquetaUncheck(ByVal idEtiqueta As Integer)
        Dim estaZoomActivado As Boolean
        estaZoomActivado = MiVisor.ZoomActivado()
        If estaZoomActivado Then
            MiAplicacion.noVisualizarEtiquetaZoom(idEtiqueta)
        Else
            MiAplicacion.noVisualizarEtiqueta(idEtiqueta)
        End If
    End Sub

    Public Sub llamaZoom()
        MiVisor.zoom()
    End Sub

    Public Sub mostrarImagenOriginal()
        MiVisor.mostrarImagenOriginal()
    End Sub

    'En la barra de herramientas ocultar/mostrar botones de zoom y Reset
    Public Sub mostrarBotonZoom()
        MiBarra.mostrarBotonZoom()
    End Sub

    Public Sub ocultarBotonZoom()
        MiBarra.ocultarBotonZoom()
    End Sub

    Public Sub mostrarBotonReset()
        MiBarra.mostrarBotonReset()
    End Sub

    Public Sub ocultarBotonReset()
        MiBarra.ocultarBotonReset()
    End Sub

    Public Sub mostrarBotonLimpiar()
        MiBarra.mostrarBotonLimpiar()
    End Sub

    Public Sub ocultarBotonLimpiar()
        MiBarra.ocultarBotonLimpiar()
    End Sub

    'Mirar si el zoom se ha activado
    Public Function EstaZoomActivado() As Boolean
        Return Me.MiVisor.ZoomActivado()
    End Function

    'Cambiar el color de la etiqueta
    Public Sub llamaACambiarColor(ByVal idEtiqueta As Integer, ByVal CambiarColorEtiqueta As SolidColorBrush)
        Dim query3 = (From etiquetaEntera In Stado.cntxtIMaGe.EtiquetasImagens Where etiquetaEntera.Id = idEtiqueta Select etiquetaEntera)
        query3.First.Color = CambiarColorEtiqueta.Color.ToString
        Stado.cntxtIMaGe.SubmitChanges(AddressOf OnSubmitCompleted, Nothing)

        MiAplicacion.CambiarColorEtiqueta(idEtiqueta, CambiarColorEtiqueta)
    End Sub

    Public Function BuscarColorRectangulo(ByVal idEtiqueta As Integer) As SolidColorBrush
        Dim etiq As Etiqueta
        etiq = MiAplicacion.buscaEtiqueta(idEtiqueta)
        If etiq.Equals(Nothing) Then
            Return Nothing
        Else
            Return etiq.get_ColorRectangulo()
        End If
    End Function

    Public Sub mostrarEtiquetasZoom()
        Dim listaImagenes As New List(Of Etiqueta)
        listaImagenes = MiAplicacion.get_ListaImagenes()
        Dim lista As New List(Of Double)
        lista = MiVisor.DistanciasRectangulo
        MiArbol.mostrarEtiquetasDelZoom(listaImagenes, lista)
    End Sub

    'Para quitar las etiquetas check de las etiquetas que están sin zoom
    Public Sub quitarCheck()
        MiArbol.quitarHojacheck()
    End Sub

    'Para poner las etiquetas con el zoom que tienen el check
    Public Sub ponerCheck()
        MiArbol.ponerHojacheck()
    End Sub

    Public Function buscaEtiqueta(ByVal idEtiqueta As Integer) As Etiqueta
        Return MiAplicacion.buscaEtiqueta(idEtiqueta)
    End Function

    'En el zoom, si las hojas están inactivas, ponerlas activas para que se vean en la imagen original
    Public Sub ponerHojasActivas()
        MiArbol.ActivarHojas()
    End Sub

    'Para cambiar el cursor al mover la imagen
    Public Sub ponerIconoMano()
        MiVisor.iconoMano()
    End Sub

    'Que se active la función de etiquetado en el visor
    Public Sub ActivarEtiquetado()
        MiVisor.EtiquetarImagen()
    End Sub

    'Que se desactive la función de etiquetado en el visor
    Public Sub DesactivarEtiquetado()
        MiVisor.EtiquetarImagenDesactivar()
    End Sub

    'Poner la flecha de cursor
    Public Sub ponerCursorOriginal()
        MiVisor.PonerCursorOriginal()
    End Sub

    'Deshabilitar los movimientos en la imagen
    Public Sub eliminarMovimientos()
        MiVisor.EliminarMovimientosDeImagen()
    End Sub

    'Cuando el zoom está activado y movemos la imagen
    Public Sub ponerHojaZoom(ByVal lista As List(Of Double))
        MiArbol.ponerHojaZoom(lista)
    End Sub

    'Cuando cambiar la imagen de la galeria, para que la barra de herramientas salga bien.
    Public Sub CambioDeImagenEnBarra()
        MiBarra.CambioDeImagenEnBarra()
    End Sub

    'Obtener la id de la imagen actual
    Public Function ObtenerIdImagen() As Integer
        Return MiGaleria.getIdImagen()
    End Function

    'Cargar al árbol nada más empezar la aplicación
    Public Sub CargarArbol(ByVal idImagen As Integer)
        MiArbol.cargarArbol(idImagen)
    End Sub

End Class
